/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the license
 * you should have received along with this software; either version 1.1 of
 * the license, or (at your option) any later version.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */

#define OBST_IMP_STREAM
#include "obst_stdinc.h"

#include "obst.h"
#include "External_use.h"
#include "../include/string_utils.h"

int main (int argc, char* argv[])
{  obst_init (argc, argv);

   C c_obj      = C::create (TEMP_CONTAINER);
   my_Double v = 1234.56;

   c_obj.set_val (v);

   cout << "Value stored in/read from a component (must be "
	<< v << "): " << c_obj.get_val() << "\n";
  
   sos_Cstring txt  = "1234.56";
   sos_Object  obj  = make_my_Double_object_from_string (txt);

   cout << "Value converted from/to an sos_String (must be "
	<< txt << "): " << make_string_from_my_Double_object (obj) << "\n";

   return 0;
}
