/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the license
 * you should have received along with this software; either version 1.1 of
 * the license, or (at your option) any later version.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */

#include <stream.h>
#include "TextFile_obst.h"

void TextFile::set (sos_Cstring cs)
{  sos_String s = sos_String::create (self.container());
   s.assign_Cstring (cs);
   self.set_contents (s);
   self.set_size (s.get_length());
}

void TextFile::append (UnixFile f)
{  if (f.has_type (TextFile_type))
   {  TextFile tf = TextFile::make (f);
      self.get_contents() += tf.get_contents();
      self.UnixFile::append (f);
   }
   else
      cerr << "Error: invalid parameter type\n";   
}

void TextFile::append (UnixFile f, sos_String separator)
{  self.get_contents() += separator;
   self.append (f);
   self.set_size (self.get_size() + separator.get_length());
}

