#ifndef knl_IMPL_H
#define knl_IMPL_H 1
#ifdef __GNUG__
#pragma interface
#endif
#include "knl_use.h"
class _sos_Object;
class _sos_Ordered_object;
class _sos_Scalar_object;
class _sos_String;
class _sos_Named;
class _sos_Type;
extern void**_knl_obj_;
sos_Cstring make_string_from_sos_Short_object(const sos_Object&);
sos_Object make_sos_Short_object_from_string(const sos_Cstring);
sos_Cstring make_string_from_sos_Int_object(const sos_Object&);
sos_Object make_sos_Int_object_from_string(const sos_Cstring);
sos_Cstring make_string_from_sos_Float_object(const sos_Object&);
sos_Object make_sos_Float_object_from_string(const sos_Cstring);
sos_Cstring make_string_from_sos_Double_object(const sos_Object&);
sos_Object make_sos_Double_object_from_string(const sos_Cstring);
sos_Cstring make_string_from_sos_Char_object(const sos_Object&);
sos_Object make_sos_Char_object_from_string(const sos_Cstring);
sos_Cstring make_string_from_sos_Cstring_object(const sos_Object&);
sos_Object make_sos_Cstring_object_from_string(const sos_Cstring);
sos_Cstring make_string_from_sos_Pointer_object(const sos_Object&);
sos_Object make_sos_Pointer_object_from_string(const sos_Cstring);
sos_Cstring make_string_from_sos_CppFctPtr_object(const sos_Object&);
sos_Object make_sos_CppFctPtr_object_from_string(const sos_Cstring);
sos_Cstring make_string_from_sos_Id_object(const sos_Object&);
sos_Object make_sos_Id_object_from_string(const sos_Cstring);
sos_Cstring make_string_from_sos_Container_object(const sos_Object&);
sos_Object make_sos_Container_object_from_string(const sos_Cstring);
sos_Cstring make_string_from_sos_Offset_object(const sos_Object&);
sos_Object make_sos_Offset_object_from_string(const sos_Cstring);
class _sos_Object:virtual public _obst_Root_class
{  friend class sos_Object;
public:
   virtual sos_Object _clone(const sos_Typed_id&,OBST_PARDECL(sos_Container))const;
private:
   virtual sos_Id get_type_id(const sos_Typed_id&)const;
   virtual void set_type_id(const sos_Typed_id&,OBST_PARDECL(sos_Id))const;
public:
   virtual void destroy(const sos_Typed_id&)const;
   virtual void assign(const sos_Typed_id&,OBST_PARDECL(sos_Object))const;
   virtual sos_Bool equal(const sos_Typed_id&,OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   virtual sos_Int hash_value(const sos_Typed_id&)const;
   sos_Type type(const sos_Typed_id&)const;
   sos_Bool has_type(const sos_Typed_id&,OBST_PARDECL(sos_Type))const;
   sos_Bool isa(const sos_Typed_id&,OBST_PARDECL(sos_Type))const;
   sos_Bool is_some(const sos_Typed_id&,OBST_PARDECL(sos_Type))const;
   sos_Bool is_value(const sos_Typed_id&)const;
   virtual sos_Int size(const sos_Typed_id&)const;
   virtual sos_Bool like(const sos_Typed_id&,OBST_PARDECL(sos_Object))const;
protected:
   static void local_assign(OBST_PARDECL(sos_Object),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(sos_Object),OBST_PARDECL(sos_Object),sos_Eq_kind);
   static sos_Int local_hash_value(OBST_PARDECL(sos_Object));
};
class _sos_Ordered_object:virtual public _sos_Object
{  friend class sos_Ordered_object;
public:
   virtual sos_Comp_result compare(const sos_Typed_id&,OBST_PARDECL(sos_Ordered_object))OBST_ISPURE
   virtual sos_Bool __less(const sos_Typed_id&,OBST_PARDECL(sos_Ordered_object))const;
   virtual sos_Bool __less_equal(const sos_Typed_id&,OBST_PARDECL(sos_Ordered_object))const;
   virtual sos_Bool __greater(const sos_Typed_id&,OBST_PARDECL(sos_Ordered_object))const;
   virtual sos_Bool __greater_equal(const sos_Typed_id&,OBST_PARDECL(sos_Ordered_object))const;
};
class _sos_Scalar_object:virtual public _sos_Object
{  friend class sos_Scalar_object;
public:
   _sos_Scalar_object(OBST_NO_ARGS){_size=8;}
   virtual void destroy(const sos_Typed_id&)const;
   virtual void assign(const sos_Typed_id&,OBST_PARDECL(sos_Object))const;
   virtual sos_Bool equal(const sos_Typed_id&,OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   virtual sos_Int hash_value(const sos_Typed_id&)const;
   static void local_initialize(OBST_PARDECL(sos_Scalar_object));
protected:
   static void local_finalize(OBST_PARDECL(sos_Scalar_object));
   static void total_assign(OBST_PARDECL(sos_Scalar_object),OBST_PARDECL(sos_Object));
   static sos_Bool total_equal(OBST_PARDECL(sos_Scalar_object),OBST_PARDECL(sos_Object),sos_Eq_kind);
   static sos_Int total_hash_value(OBST_PARDECL(sos_Scalar_object));
};
#define _sos_Scalar_object_OBJ_ ((_sos_Scalar_object*)_knl_obj_[0])
class _sos_String:virtual public _sos_Ordered_object
{  friend class sos_String;
   virtual sos_Offset _offset_sos_String(OBST_NO_ARGS)const {return 8;}
public:
   _sos_String(OBST_NO_ARGS){_size=16;}
   virtual sos_Object _clone(const sos_Typed_id&,OBST_PARDECL(sos_Container))const;
   virtual void destroy(const sos_Typed_id&)const;
   virtual sos_Int hash_value(const sos_Typed_id&)const;
   virtual sos_Int get_length(const sos_Typed_id&)const;
private:
   virtual void set_length(const sos_Typed_id&,OBST_PARDECL(sos_Int))const;
public:
   virtual sos_Cstring make_Cstring(const sos_Typed_id&)const;
   virtual sos_Cstring _make_Cstring(const sos_Typed_id&)const;
   virtual void __plus_assign(const sos_Typed_id&,OBST_PARDECL(sos_String))const;
   virtual sos_Comp_result compare(const sos_Typed_id&,OBST_PARDECL(sos_Ordered_object))const;
protected:
   static void local_assign(OBST_PARDECL(sos_String),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(sos_String),OBST_PARDECL(sos_Object),sos_Eq_kind);
public:
   static sos_String create(sos_Container,sos_Cstring);
   virtual void assign(const sos_Typed_id&,OBST_PARDECL(sos_Object))const;
   virtual sos_Bool equal(const sos_Typed_id&,OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   virtual void assign_Cstring(const sos_Typed_id&,sos_Cstring)const;
   virtual sos_Int size(const sos_Typed_id&)const;
   static void local_initialize(OBST_PARDECL(sos_String));
protected:
   static void local_finalize(OBST_PARDECL(sos_String));
   static sos_Int local_hash_value(OBST_PARDECL(sos_String));
private:
   virtual sos_Offset get_address(const sos_Typed_id&)const;
   virtual void set_address(const sos_Typed_id&,OBST_PARDECL(sos_Offset))const;
};
#define _sos_String_OBJ_ ((_sos_String*)_knl_obj_[1])
class _sos_Named:virtual public _sos_Object
{  friend class sos_Named;
public:
   virtual sos_String get_name(const sos_Typed_id&)const;
};
class _sos_Type:virtual public _sos_Named
{  friend class sos_Type;
   virtual sos_Offset _offset_sos_Type(OBST_NO_ARGS)const {return 8;}
public:
   _sos_Type(OBST_NO_ARGS){_size=24;}
   virtual sos_String get_name(const sos_Typed_id&)const;
   virtual void set_name(const sos_Typed_id&,OBST_PARDECL(sos_String))const;
   virtual sos_Bool is_derived_from(const sos_Typed_id&,OBST_PARDECL(sos_Type))const;
   virtual sos_Bool is_derived_from_some(const sos_Typed_id&,OBST_PARDECL(sos_Type))const;
   virtual sos_Bool is_scalar(const sos_Typed_id&)const;
   virtual sos_Type root(const sos_Typed_id&)const;
protected:
   static void local_assign(OBST_PARDECL(sos_Type),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(sos_Type),OBST_PARDECL(sos_Object),sos_Eq_kind);
public:
   virtual sos_Int get_object_size(const sos_Typed_id&)const;
   virtual void set_object_size(const sos_Typed_id&,OBST_PARDECL(sos_Int))const;
protected:
   static sos_Int local_hash_value(OBST_PARDECL(sos_Type));
};
#define _sos_Type_OBJ_ ((_sos_Type*)_knl_obj_[2])
#endif
