#ifndef _PSM_ERR_H
#define _PSM_ERR_H 1
/* -----------------------------------------------------------------------------
* Copyright 1992-1994 by Forschungszentrum Informatik(FZI)
 * All rights reserved.
*
* You can use and distribute this software under the terms of the license
* you should have received along with this software.
* For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
* Email: obst@xcc-ka.de.
* ------------------------------------------------------------------------------
*/
// *****************************************************************************
// Module psm                  Emil Sekerinski, Oliver Spatscheck, Walter Zimmer
//
// *****************************************************************************
//  persistent storage manager: error messages header 
// *****************************************************************************

// *****************************************************************************
// PUBLIC INCLUDEFILES
// *****************************************************************************

#include "obst_err.h"

// *****************************************************************************
// ERROR MESSAGES 
// *****************************************************************************

// ================= for PSM ===================================================

extern const err_msg err_PSM_ALLOC_NULL_BYTES;
extern const err_msg err_PSM_CNT_FCNTL_PROG_FLOCK;
extern const err_msg err_PSM_CNT_FLOCK_PROG_FCNTL;
extern const err_msg err_PSM_CONTAINER_TABLE_FULL;
extern const err_msg err_PSM_CREATE_FAILED;
extern const err_msg err_PSM_CREATE_LOCK_FAILED;
extern const err_msg err_PSM_DEALLOC_NULL_BYTES;
extern const err_msg err_PSM_DEALLOCATE_WRONG_OFFSET;
extern const err_msg err_PSM_DESTROY_DURING_CHECKOUT;
extern const err_msg err_PSM_DESTROY_ONLY_PERMITTED_FOR_WRITING;
extern const err_msg err_PSM_DESTROYED_CONTAINER;
extern const err_msg err_PSM_EXISTS;
extern const err_msg err_PSM_FREELIST_CHECK_FAILED;
extern const err_msg err_PSM_INVALID_ACCESS_MODE;
extern const err_msg err_PSM_INVALID_CURSOR;
extern const err_msg err_PSM_LOST_ALL_LOCKS;
extern const err_msg err_PSM_NO_ACCESS;
extern const err_msg err_PSM_NO_CNT_NUMBER_ONE;
extern const err_msg err_PSM_NONWRITEABLE_CONTAINER;
extern const err_msg err_PSM_OPEN_ON_TEMP;
extern const err_msg err_PSM_OPEN_TWICE;
extern const err_msg err_PSM_OPERATION_DELETED_DONT_USE;
extern const err_msg err_PSM_PATH_TOO_LONG;
extern const err_msg err_PSM_SQUEEZE_WITH_WRONG_STATUS;
extern const err_msg err_PSM_TEMP_FULL;
extern const err_msg err_PSM_UNOPENED_CONTAINER;
extern const err_msg err_PSM_WRITEPAGE;
extern const err_msg err_PSM_WRONG_OFFSET;
extern const err_msg err_PSM_WRONG_OFFSET_IN_OBJ_EXIST;

extern const err_msg err_CNT_USAGE;
extern const err_msg err_CNT_OPEN_FAILED;
extern const err_msg err_CNT_CONTAINER_BUSY;

extern const err_msg err_NO_CONTAINER_PATH;

// ================= for MON ===================================================

extern const err_msg err_MON_SERVER_CONNECTION_FAILED;
extern const err_msg err_MON_PIXMAP_CREATION_FAILED;

// ================= for JOYCE =================================================

extern const err_msg err_PSM_CONTAINER_STILL_OPEN;
extern const err_msg err_PSM_NO_SYNC_CONTAINER;
extern const err_msg err_PSM_NO_WRITEOPEN_CONTAINER;
extern const err_msg err_PSM_SYCT_OPEN_RCL;
extern const err_msg err_PSM_SYCT_OPEN_WCL;
extern const err_msg err_PSM_SYCT_READ_CLOSE;
extern const err_msg err_PSM_SYCT_WRITE_CLOSE;
extern const err_msg err_PSM_SYCT_WRONG_ACCESS;
extern const err_msg err_PSM_SYNC;
extern const err_msg err_PSM_SYNC_IMPLTA_ABORTED;
extern const err_msg err_PSM_SYNC_NOT_ACTIVATED;
extern const err_msg err_PSM_SYNC_TA_ABORTED;
extern const err_msg err_PSM_WRITE_CLOSE;
#endif
