#ifndef agg_USE_H
#define agg_USE_H 1
#include "obst_config.h"
#include "knl_use.h"
enum agg_Impl { AGG_HASH,AGG_LIST,AGG_AUTOMATIC };
typedef sos_Int Index;
#define make_Index_object make_sos_Int_object
#define make_Index make_sos_Int
#define Index_type sos_Int_type
class sos_Aggregate;
class sos_Object_Collection;
class sos_Object_sos_Object_Association;
class sos_Cursor;
class sos_Object_List;
class sos_Object_Array;
class sos_Object_sos_Object_Mapping_impl;
class sos_Object_sos_Object_Mapping;
class sos_Object_sos_Object_Mapping_List;
class sos_Object_sos_Object_Mapping_Hash;
class sos_Object_Bag;
class sos_Object_sos_Int_Mapping;
class sos_Object_sos_Int_Association;
class sos_Object_Set;
class sos_Node;
class sos_Array_node;
class sos_List_node;
class sos_Mapping_node;
class sos_Mapping_List_node;
class sos_Bag_node;
class sos_Int_Set;
class sos_Int_Collection;
class sos_String_List;
class sos_String_Collection;
#include "agg_ext.h"
extern sos_Id*_agg__tp_;
extern sos_Type*_agg_tp_;
inline void bcopy_from_agg_Impl(void*e,void*c)
{*(sos_Char*)c=(sos_Char)*(agg_Impl*)e;}
inline void bcopy_to_agg_Impl(void*e,void*c)
{*(agg_Impl*)e=(agg_Impl)*(sos_Char*)c;}
sos_Object make_agg_Impl_object(const agg_Impl);
agg_Impl make_agg_Impl(const sos_Object&);
#define _agg_Impl_type _agg__tp_[0]
#define agg_Impl_type _agg_tp_[0]
class sos_Aggregate: public obst_Root_class 
{  friend class _sos_Aggregate;
   const class _sos_Aggregate*_impl;
public :
   operator sos_Object(OBST_NO_ARGS) const;
   static sos_Aggregate make(const sos_Typed_id&);
   static sos_Aggregate make(const sos_Typed_id&_OBSThis,const _sos_Aggregate *_y){
         sos_Aggregate _x;_x._self=_OBSThis;_x._impl=_y;return _x;
   }
   static sos_Aggregate make(const obst_Root_class&);
   static sos_Aggregate clone(OBST_PARDECL(sos_Aggregate),sos_Container);
   void destroy(OBST_NO_ARGS)const;
   sos_Int hash_value(OBST_NO_ARGS)const;
   void change(sos_Cstring,sos_Cstring)const;
   sos_Bool is_empty(OBST_NO_ARGS)const;
   sos_Int card(OBST_NO_ARGS)const;
   sos_Cursor open_cursor(sos_Container =TEMP_CONTAINER)const;
   void close_cursor(OBST_PARDECL(sos_Cursor))const;
   sos_Cursor duplicate(OBST_PARDECL(sos_Cursor),sos_Container =TEMP_CONTAINER)const;
   sos_Bool is_valid(OBST_PARDECL(sos_Cursor))const;
   void remove_at(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_first(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_last(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_pred(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
   sos_Bool has_type(OBST_PARDECL(sos_Type))const;
   sos_Bool isa(OBST_PARDECL(sos_Type))const;
protected:
   static void local_assign(OBST_PARDECL(sos_Aggregate),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(sos_Aggregate),OBST_PARDECL(sos_Object),sos_Eq_kind);
public:
   sos_Bool like(OBST_PARDECL(sos_Object))const;
   void assign(OBST_PARDECL(sos_Object))const;
   sos_Bool equal(OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   void clear(OBST_NO_ARGS)const;
   sos_Bool to_succ(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
   sos_Bool get_list_cursor(OBST_NO_ARGS)const;
   void set_list_cursor(sos_Bool)const;
   sos_Type type(OBST_NO_ARGS)const;
   sos_Bool is_some(OBST_PARDECL(sos_Type))const;
   sos_Bool is_value(OBST_NO_ARGS)const;
   sos_Int size(OBST_NO_ARGS)const;
protected:
   static sos_Int local_hash_value(OBST_PARDECL(sos_Aggregate));
};
OBST_TMPDEF(extern,sos_Aggregate,_sos_Aggregate_tmp)
#define _sos_Aggregate_type _agg__tp_[1]
#define sos_Aggregate_type _agg_tp_[1]
class sos_Object_Collection: public obst_Root_class 
{  friend class _sos_Object_Collection;
   const class _sos_Object_Collection*_impl;
public :
   operator sos_Object(OBST_NO_ARGS) const;
   operator sos_Aggregate(OBST_NO_ARGS) const;
   static sos_Object_Collection make(const sos_Typed_id&);
   static sos_Object_Collection make(const sos_Typed_id&_OBSThis,const _sos_Object_Collection *_y){
         sos_Object_Collection _x;_x._self=_OBSThis;_x._impl=_y;return _x;
   }
   static sos_Object_Collection make(const obst_Root_class&);
   static sos_Object_Collection clone(OBST_PARDECL(sos_Object_Collection),sos_Container);
   void destroy(OBST_NO_ARGS)const;
   sos_Int hash_value(OBST_NO_ARGS)const;
   sos_Bool is_element(OBST_PARDECL(sos_Object))const;
   sos_Object get(OBST_PARDECL(sos_Cursor))const;
protected:
   static void local_assign(OBST_PARDECL(sos_Object_Collection),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(sos_Object_Collection),OBST_PARDECL(sos_Object),sos_Eq_kind);
public:
   void change(sos_Cstring,sos_Cstring)const;
   sos_Bool is_empty(OBST_NO_ARGS)const;
   sos_Int card(OBST_NO_ARGS)const;
   sos_Cursor open_cursor(sos_Container =TEMP_CONTAINER)const;
   void close_cursor(OBST_PARDECL(sos_Cursor))const;
   sos_Cursor duplicate(OBST_PARDECL(sos_Cursor),sos_Container =TEMP_CONTAINER)const;
   sos_Bool is_valid(OBST_PARDECL(sos_Cursor))const;
   void remove_at(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_first(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_last(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_pred(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
   sos_Bool has_type(OBST_PARDECL(sos_Type))const;
   sos_Bool isa(OBST_PARDECL(sos_Type))const;
   void assign(OBST_PARDECL(sos_Object))const;
   sos_Bool equal(OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
protected:
   sos_Bool get_based_on_equal(OBST_NO_ARGS)const;
   void set_based_on_equal(sos_Bool)const;
   static sos_Int local_hash_value(OBST_PARDECL(sos_Object_Collection));
public:
   sos_Bool like(OBST_PARDECL(sos_Object))const;
   void clear(OBST_NO_ARGS)const;
   sos_Bool to_succ(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
   sos_Bool get_list_cursor(OBST_NO_ARGS)const;
   void set_list_cursor(sos_Bool)const;
   sos_Type type(OBST_NO_ARGS)const;
   sos_Bool is_some(OBST_PARDECL(sos_Type))const;
   sos_Bool is_value(OBST_NO_ARGS)const;
   sos_Int size(OBST_NO_ARGS)const;
};
OBST_TMPDEF(extern,sos_Object_Collection,_sos_Object_Collection_tmp)
#define _sos_Object_Collection_type _agg__tp_[2]
#define sos_Object_Collection_type _agg_tp_[2]
class sos_Object_sos_Object_Association: public obst_Root_class 
{  friend class _sos_Object_sos_Object_Association;
   const class _sos_Object_sos_Object_Association*_impl;
public :
   operator sos_Object(OBST_NO_ARGS) const;
   operator sos_Aggregate(OBST_NO_ARGS) const;
   static sos_Object_sos_Object_Association make(const sos_Typed_id&);
   static sos_Object_sos_Object_Association make(const sos_Typed_id&_OBSThis,const _sos_Object_sos_Object_Association *_y){
         sos_Object_sos_Object_Association _x;_x._self=_OBSThis;_x._impl=_y;return _x;
   }
   static sos_Object_sos_Object_Association make(const obst_Root_class&);
   static sos_Object_sos_Object_Association clone(OBST_PARDECL(sos_Object_sos_Object_Association),sos_Container);
   void destroy(OBST_NO_ARGS)const;
   sos_Int hash_value(OBST_NO_ARGS)const;
   sos_Bool is_role2(OBST_PARDECL(sos_Object))const;
   sos_Object get_role1(OBST_PARDECL(sos_Cursor))const;
   sos_Object get_role2(OBST_PARDECL(sos_Cursor))const;
protected:
   static void local_assign(OBST_PARDECL(sos_Object_sos_Object_Association),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(sos_Object_sos_Object_Association),OBST_PARDECL(sos_Object),sos_Eq_kind);
public:
   void change(sos_Cstring,sos_Cstring)const;
   sos_Bool is_empty(OBST_NO_ARGS)const;
   sos_Int card(OBST_NO_ARGS)const;
   sos_Cursor open_cursor(sos_Container =TEMP_CONTAINER)const;
   void close_cursor(OBST_PARDECL(sos_Cursor))const;
   sos_Cursor duplicate(OBST_PARDECL(sos_Cursor),sos_Container =TEMP_CONTAINER)const;
   sos_Bool is_valid(OBST_PARDECL(sos_Cursor))const;
   void remove_at(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_first(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_last(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_pred(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
   sos_Bool has_type(OBST_PARDECL(sos_Type))const;
   sos_Bool isa(OBST_PARDECL(sos_Type))const;
   void assign(OBST_PARDECL(sos_Object))const;
   sos_Bool equal(OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   sos_Bool is_role1(OBST_PARDECL(sos_Object))const;
protected:
   sos_Bool get_role1_based_on_equal(OBST_NO_ARGS)const;
   void set_role1_based_on_equal(sos_Bool)const;
   sos_Bool get_role2_based_on_equal(OBST_NO_ARGS)const;
   void set_role2_based_on_equal(sos_Bool)const;
   static sos_Int local_hash_value(OBST_PARDECL(sos_Object_sos_Object_Association));
public:
   sos_Bool like(OBST_PARDECL(sos_Object))const;
   void clear(OBST_NO_ARGS)const;
   sos_Bool to_succ(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
   sos_Bool get_list_cursor(OBST_NO_ARGS)const;
   void set_list_cursor(sos_Bool)const;
   sos_Type type(OBST_NO_ARGS)const;
   sos_Bool is_some(OBST_PARDECL(sos_Type))const;
   sos_Bool is_value(OBST_NO_ARGS)const;
   sos_Int size(OBST_NO_ARGS)const;
};
OBST_TMPDEF(extern,sos_Object_sos_Object_Association,_sos_Object_sos_Object_Association_tmp)
#define _sos_Object_sos_Object_Association_type _agg__tp_[3]
#define sos_Object_sos_Object_Association_type _agg_tp_[3]
class sos_Cursor: public obst_Root_class 
{  friend class _sos_Cursor;
   const class _sos_Cursor*_impl;
public :
   operator sos_Object(OBST_NO_ARGS) const;
   static sos_Cursor make(const sos_Typed_id&);
   static sos_Cursor make(const sos_Typed_id&_OBSThis,const _sos_Cursor *_y){
         sos_Cursor _x;_x._self=_OBSThis;_x._impl=_y;return _x;
   }
   static sos_Cursor make(const obst_Root_class&);
   static sos_Cursor clone(OBST_PARDECL(sos_Cursor),sos_Container);
   void destroy(OBST_NO_ARGS)const;
   sos_Int hash_value(OBST_NO_ARGS)const;
   sos_Bool defined_for(OBST_PARDECL(sos_Aggregate))const;
private:
   sos_Aggregate get_domain(OBST_NO_ARGS)const;
   void set_domain(OBST_PARDECL(sos_Aggregate))const;
public:
   sos_Bool has_type(OBST_PARDECL(sos_Type))const;
   sos_Bool isa(OBST_PARDECL(sos_Type))const;
protected:
   static void local_assign(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object),sos_Eq_kind);
public:
   static sos_Cursor create(sos_Container,OBST_PARDECL(sos_Aggregate));
   static sos_Cursor copy(OBST_PARDECL(sos_Cursor),sos_Container);
   void assign(OBST_PARDECL(sos_Object))const;
   sos_Bool equal(OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   sos_Node get_current(OBST_NO_ARGS)const;
   void set_current(OBST_PARDECL(sos_Node))const;
protected:
   static void local_initialize(OBST_PARDECL(sos_Cursor));
public:
   sos_Type type(OBST_NO_ARGS)const;
   sos_Bool is_some(OBST_PARDECL(sos_Type))const;
   sos_Bool is_value(OBST_NO_ARGS)const;
   sos_Int size(OBST_NO_ARGS)const;
   sos_Bool like(OBST_PARDECL(sos_Object))const;
protected:
   static sos_Int local_hash_value(OBST_PARDECL(sos_Cursor));
};
OBST_TMPDEF(extern,sos_Cursor,_sos_Cursor_tmp)
#define _sos_Cursor_type _agg__tp_[4]
#define sos_Cursor_type _agg_tp_[4]
class sos_Object_List: public obst_Root_class 
{  friend class _sos_Object_List;
   const class _sos_Object_List*_impl;
public :
   operator sos_Object(OBST_NO_ARGS) const;
   operator sos_Aggregate(OBST_NO_ARGS) const;
   operator sos_Object_Collection(OBST_NO_ARGS) const;
   static sos_Object_List make(const sos_Typed_id&);
   static sos_Object_List make(const sos_Typed_id&_OBSThis,const _sos_Object_List *_y){
         sos_Object_List _x;_x._self=_OBSThis;_x._impl=_y;return _x;
   }
   static sos_Object_List make(const obst_Root_class&);
   void destroy(OBST_NO_ARGS)const;
   sos_Int hash_value(OBST_NO_ARGS)const;
   sos_Int find(OBST_PARDECL(sos_Object))const;
   void operator+=(OBST_PARDECL(sos_Object_List))const;
   void set(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object))const;
   sos_Object get(OBST_PARDECL(sos_Cursor))const;
   sos_Int card(OBST_NO_ARGS)const;
   sos_Cursor open_cursor(sos_Container =TEMP_CONTAINER)const;
   void close_cursor(OBST_PARDECL(sos_Cursor))const;
   sos_Cursor duplicate(OBST_PARDECL(sos_Cursor),sos_Container =TEMP_CONTAINER)const;
   sos_Bool to_last(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_pred(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
protected:
   static void local_assign(OBST_PARDECL(sos_Object_List),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(sos_Object_List),OBST_PARDECL(sos_Object),sos_Eq_kind);
private:
   sos_Offset get_first(OBST_NO_ARGS)const;
   void set_first(sos_Offset)const;
   sos_Container get_default_container(OBST_NO_ARGS)const;
   void set_default_container(sos_Container)const;
   sos_Id get_default_type(OBST_NO_ARGS)const;
   void set_default_type(sos_Id)const;
public:
   sos_Bool is_element(OBST_PARDECL(sos_Object))const;
   sos_Bool is_empty(OBST_NO_ARGS)const;
   sos_Bool isa(OBST_PARDECL(sos_Type))const;
   static sos_Object_List create(sos_Container,sos_Bool =FALSE,sos_Bool =FALSE);
   static sos_Object_List copy(OBST_PARDECL(sos_Object_List),sos_Container);
   void assign(OBST_PARDECL(sos_Object))const;
   sos_Bool equal(OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   void append(OBST_PARDECL(sos_Object))const;
   void insert(sos_Int,OBST_PARDECL(sos_Object))const;
   void clear(OBST_NO_ARGS)const;
   sos_Int size(OBST_NO_ARGS)const;
   sos_Int current_pos(OBST_PARDECL(sos_Cursor))const;
   void insert_before(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object))const;
protected:
   static void local_finalize(OBST_PARDECL(sos_Object_List));
private:
   void set_prev(sos_Offset,sos_Offset)const;
   void remove_node(sos_Offset,sos_Offset,sos_Offset)const;
protected:
   sos_Bool get_based_on_equal(OBST_NO_ARGS)const;
   void set_based_on_equal(sos_Bool)const;
public:
   sos_Bool like(OBST_PARDECL(sos_Object))const;
   sos_Bool get_list_cursor(OBST_NO_ARGS)const;
   void set_list_cursor(sos_Bool)const;
   sos_Type type(OBST_NO_ARGS)const;
   static sos_Object_List clone(OBST_PARDECL(sos_Object_List),sos_Container);
   sos_Object find_or_append(OBST_PARDECL(sos_Object))const;
   void insert_after(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object))const;
   void remove_at(OBST_PARDECL(sos_Cursor))const;
   sos_Bool is_valid(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_first(OBST_PARDECL(sos_Cursor))const;
   void change_list_cursor(sos_Bool)const;
private:
   sos_Int get_size(OBST_NO_ARGS)const;
   void set_size(sos_Int)const;
public:
   void change(sos_Cstring,sos_Cstring)const;
   sos_Bool has_type(OBST_PARDECL(sos_Type))const;
   void remove(sos_Int)const;
   sos_Object get_nth(sos_Int)const;
   void set_nth(sos_Int,OBST_PARDECL(sos_Object))const;
   sos_Bool move_cursor(OBST_PARDECL(sos_Cursor),sos_Int)const;
   sos_Bool to_succ(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
protected:
   static void local_initialize(OBST_PARDECL(sos_Object_List));
   static sos_Int local_hash_value(OBST_PARDECL(sos_Object_List));
private:
   sos_Offset get_last(OBST_NO_ARGS)const;
   void set_last(sos_Offset)const;
   sos_Int get_cardinality(OBST_NO_ARGS)const;
   void set_cardinality(sos_Int)const;
   sos_Offset create_node(OBST_PARDECL(sos_Object),sos_Offset,sos_Offset)const;
   void set_next(sos_Offset,sos_Offset)const;
public:
   sos_Bool is_some(OBST_PARDECL(sos_Type))const;
   sos_Bool is_value(OBST_NO_ARGS)const;
};
OBST_TMPDEF(extern,sos_Object_List,_sos_Object_List_tmp)
#define _sos_Object_List_type _agg__tp_[5]
#define sos_Object_List_type _agg_tp_[5]
class sos_Object_Array: public obst_Root_class 
{  friend class _sos_Object_Array;
   const class _sos_Object_Array*_impl;
public :
   operator sos_Object(OBST_NO_ARGS) const;
   operator sos_Aggregate(OBST_NO_ARGS) const;
   operator sos_Object_Collection(OBST_NO_ARGS) const;
   static sos_Object_Array make(const sos_Typed_id&);
   static sos_Object_Array make(const sos_Typed_id&_OBSThis,const _sos_Object_Array *_y){
         sos_Object_Array _x;_x._self=_OBSThis;_x._impl=_y;return _x;
   }
   static sos_Object_Array make(const obst_Root_class&);
   static sos_Object_Array clone(OBST_PARDECL(sos_Object_Array),sos_Container);
   void destroy(OBST_NO_ARGS)const;
   sos_Int hash_value(OBST_NO_ARGS)const;
   void shift(sos_Int,sos_Int)const;
   sos_Object operator[](sos_Int)const;
   void set(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object))const;
   sos_Object get(OBST_PARDECL(sos_Cursor))const;
   void remove_at(OBST_PARDECL(sos_Cursor))const;
   sos_Int card(OBST_NO_ARGS)const;
   sos_Cursor open_cursor(sos_Container =TEMP_CONTAINER)const;
   void close_cursor(OBST_PARDECL(sos_Cursor))const;
   sos_Cursor duplicate(OBST_PARDECL(sos_Cursor),sos_Container =TEMP_CONTAINER)const;
   sos_Bool is_valid(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_first(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_last(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_pred(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
   void change_list_cursor(sos_Bool)const;
protected:
   static void local_assign(OBST_PARDECL(sos_Object_Array),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(sos_Object_Array),OBST_PARDECL(sos_Object),sos_Eq_kind);
private:
   sos_Int get_bottom_index(OBST_NO_ARGS)const;
   void set_bottom_index(sos_Int)const;
public:
   sos_Bool is_element(OBST_PARDECL(sos_Object))const;
   void change(sos_Cstring,sos_Cstring)const;
   sos_Bool is_empty(OBST_NO_ARGS)const;
   sos_Bool has_type(OBST_PARDECL(sos_Type))const;
   sos_Bool isa(OBST_PARDECL(sos_Type))const;
   static sos_Object_Array create(sos_Container,sos_Int,sos_Int,sos_Bool =FALSE,sos_Bool =FALSE);
   static sos_Object_Array copy(OBST_PARDECL(sos_Object_Array),sos_Container);
   void assign(OBST_PARDECL(sos_Object))const;
   sos_Bool equal(OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   void rotate(sos_Int)const;
   sos_Int current_pos(OBST_PARDECL(sos_Cursor))const;
   sos_Int size(OBST_NO_ARGS)const;
protected:
   static void local_finalize(OBST_PARDECL(sos_Object_Array));
private:
   sos_Int get_top_index(OBST_NO_ARGS)const;
   void set_top_index(sos_Int)const;
   sos_Offset get_address(OBST_NO_ARGS)const;
   void set_address(sos_Offset)const;
protected:
   sos_Bool get_based_on_equal(OBST_NO_ARGS)const;
   void set_based_on_equal(sos_Bool)const;
public:
   sos_Bool like(OBST_PARDECL(sos_Object))const;
   void clear(OBST_NO_ARGS)const;
   sos_Bool get_list_cursor(OBST_NO_ARGS)const;
   void set_list_cursor(sos_Bool)const;
   sos_Type type(OBST_NO_ARGS)const;
   sos_Int get_bottom(OBST_NO_ARGS)const;
   sos_Int get_top(OBST_NO_ARGS)const;
   sos_Object get_nth(sos_Int)const;
   void set_nth(sos_Int,OBST_PARDECL(sos_Object))const;
   sos_Bool move_cursor(OBST_PARDECL(sos_Cursor),sos_Int)const;
   sos_Bool to_succ(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
protected:
   static void local_initialize(OBST_PARDECL(sos_Object_Array));
   static sos_Int local_hash_value(OBST_PARDECL(sos_Object_Array));
private:
   sos_Int element_size(OBST_NO_ARGS)const;
public:
   sos_Bool is_some(OBST_PARDECL(sos_Type))const;
   sos_Bool is_value(OBST_NO_ARGS)const;
};
OBST_TMPDEF(extern,sos_Object_Array,_sos_Object_Array_tmp)
#define _sos_Object_Array_type _agg__tp_[6]
#define sos_Object_Array_type _agg_tp_[6]
class sos_Object_sos_Object_Mapping_impl: public obst_Root_class 
{  friend class _sos_Object_sos_Object_Mapping_impl;
   const class _sos_Object_sos_Object_Mapping_impl*_impl;
public :
   operator sos_Object(OBST_NO_ARGS) const;
   operator sos_Aggregate(OBST_NO_ARGS) const;
   operator sos_Object_sos_Object_Association(OBST_NO_ARGS) const;
   static sos_Object_sos_Object_Mapping_impl make(const sos_Typed_id&);
   static sos_Object_sos_Object_Mapping_impl make(const sos_Typed_id&_OBSThis,const _sos_Object_sos_Object_Mapping_impl *_y){
         sos_Object_sos_Object_Mapping_impl _x;_x._self=_OBSThis;_x._impl=_y;return _x;
   }
   static sos_Object_sos_Object_Mapping_impl make(const obst_Root_class&);
   static sos_Object_sos_Object_Mapping_impl clone(OBST_PARDECL(sos_Object_sos_Object_Mapping_impl),sos_Container);
   void destroy(OBST_NO_ARGS)const;
   sos_Int hash_value(OBST_NO_ARGS)const;
   sos_Object operator[](OBST_PARDECL(sos_Object))const;
   sos_Object get_info(OBST_PARDECL(sos_Cursor))const;
   void set_info(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object))const;
   void insert_after(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object),OBST_PARDECL(sos_Object))const;
   void check_node_type(OBST_PARDECL(sos_Cursor))const;
   sos_Bool is_role2(OBST_PARDECL(sos_Object))const;
   sos_Object get_role1(OBST_PARDECL(sos_Cursor))const;
   sos_Object get_role2(OBST_PARDECL(sos_Cursor))const;
   void change(sos_Cstring,sos_Cstring)const;
   sos_Bool is_empty(OBST_NO_ARGS)const;
   sos_Int card(OBST_NO_ARGS)const;
   sos_Cursor open_cursor(sos_Container =TEMP_CONTAINER)const;
   void close_cursor(OBST_PARDECL(sos_Cursor))const;
   sos_Cursor duplicate(OBST_PARDECL(sos_Cursor),sos_Container =TEMP_CONTAINER)const;
   sos_Bool is_valid(OBST_PARDECL(sos_Cursor))const;
   void remove_at(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_first(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_last(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_pred(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
   sos_Bool has_type(OBST_PARDECL(sos_Type))const;
   sos_Bool isa(OBST_PARDECL(sos_Type))const;
   void assign(OBST_PARDECL(sos_Object))const;
   sos_Bool equal(OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   sos_Bool is_key(OBST_PARDECL(sos_Object))const;
   sos_Bool is_info(OBST_PARDECL(sos_Object))const;
   void insert(OBST_PARDECL(sos_Object),OBST_PARDECL(sos_Object))const;
   void remove(OBST_PARDECL(sos_Object))const;
   sos_Object get_key(OBST_PARDECL(sos_Cursor))const;
   sos_Bool move_cursor(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object))const;
   void insert_before(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object),OBST_PARDECL(sos_Object))const;
   sos_Bool is_role1(OBST_PARDECL(sos_Object))const;
protected:
   sos_Bool get_role1_based_on_equal(OBST_NO_ARGS)const;
   void set_role1_based_on_equal(sos_Bool)const;
   sos_Bool get_role2_based_on_equal(OBST_NO_ARGS)const;
   void set_role2_based_on_equal(sos_Bool)const;
public:
   sos_Bool like(OBST_PARDECL(sos_Object))const;
   void clear(OBST_NO_ARGS)const;
   sos_Bool to_succ(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
   sos_Bool get_list_cursor(OBST_NO_ARGS)const;
   void set_list_cursor(sos_Bool)const;
   sos_Type type(OBST_NO_ARGS)const;
   sos_Bool is_some(OBST_PARDECL(sos_Type))const;
   sos_Bool is_value(OBST_NO_ARGS)const;
   sos_Int size(OBST_NO_ARGS)const;
};
OBST_TMPDEF(extern,sos_Object_sos_Object_Mapping_impl,_sos_Object_sos_Object_Mapping_impl_tmp)
#define _sos_Object_sos_Object_Mapping_impl_type _agg__tp_[7]
#define sos_Object_sos_Object_Mapping_impl_type _agg_tp_[7]
class sos_Object_sos_Object_Mapping: public obst_Root_class 
{  friend class _sos_Object_sos_Object_Mapping;
   const class _sos_Object_sos_Object_Mapping*_impl;
public :
   operator sos_Object(OBST_NO_ARGS) const;
   operator sos_Aggregate(OBST_NO_ARGS) const;
   operator sos_Object_sos_Object_Association(OBST_NO_ARGS) const;
   static sos_Object_sos_Object_Mapping make(const sos_Typed_id&);
   static sos_Object_sos_Object_Mapping make(const sos_Typed_id&_OBSThis,const _sos_Object_sos_Object_Mapping *_y){
         sos_Object_sos_Object_Mapping _x;_x._self=_OBSThis;_x._impl=_y;return _x;
   }
   static sos_Object_sos_Object_Mapping make(const obst_Root_class&);
   void destroy(OBST_NO_ARGS)const;
   sos_Int hash_value(OBST_NO_ARGS)const;
   sos_Object operator[](OBST_PARDECL(sos_Object))const;
   sos_Object get_info(OBST_PARDECL(sos_Cursor))const;
   void set_info(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object))const;
   sos_Bool is_role2(OBST_PARDECL(sos_Object))const;
   sos_Int card(OBST_NO_ARGS)const;
   sos_Cursor open_cursor(sos_Container =TEMP_CONTAINER)const;
   void close_cursor(OBST_PARDECL(sos_Cursor))const;
   sos_Cursor duplicate(OBST_PARDECL(sos_Cursor),sos_Container =TEMP_CONTAINER)const;
   sos_Bool to_last(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_pred(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
protected:
   static void local_assign(OBST_PARDECL(sos_Object_sos_Object_Mapping),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(sos_Object_sos_Object_Mapping),OBST_PARDECL(sos_Object),sos_Eq_kind);
public:
   sos_Bool is_empty(OBST_NO_ARGS)const;
   sos_Bool isa(OBST_PARDECL(sos_Type))const;
   static sos_Object_sos_Object_Mapping create(sos_Container,sos_Bool =FALSE,sos_Bool =FALSE,sos_Bool =FALSE,agg_Impl =AGG_AUTOMATIC);
   static sos_Object_sos_Object_Mapping copy(OBST_PARDECL(sos_Object_sos_Object_Mapping),sos_Container);
   void assign(OBST_PARDECL(sos_Object))const;
   sos_Bool equal(OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   sos_Bool is_info(OBST_PARDECL(sos_Object))const;
   void insert(OBST_PARDECL(sos_Object),OBST_PARDECL(sos_Object))const;
   void insert_before(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object),OBST_PARDECL(sos_Object))const;
   sos_Int size(OBST_NO_ARGS)const;
   void clear(OBST_NO_ARGS)const;
   void change_impl_type(agg_Impl)const;
protected:
   static void local_finalize(OBST_PARDECL(sos_Object_sos_Object_Mapping));
   sos_Bool get_role1_based_on_equal(OBST_NO_ARGS)const;
   void set_role1_based_on_equal(sos_Bool)const;
   sos_Bool get_role2_based_on_equal(OBST_NO_ARGS)const;
   void set_role2_based_on_equal(sos_Bool)const;
public:
   sos_Bool like(OBST_PARDECL(sos_Object))const;
   sos_Bool get_list_cursor(OBST_NO_ARGS)const;
   void set_list_cursor(sos_Bool)const;
   sos_Type type(OBST_NO_ARGS)const;
   static sos_Object_sos_Object_Mapping clone(OBST_PARDECL(sos_Object_sos_Object_Mapping),sos_Container);
   void insert_after(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object),OBST_PARDECL(sos_Object))const;
   sos_Object get_role1(OBST_PARDECL(sos_Cursor))const;
   sos_Object get_role2(OBST_PARDECL(sos_Cursor))const;
   void remove_at(OBST_PARDECL(sos_Cursor))const;
   sos_Bool is_valid(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_first(OBST_PARDECL(sos_Cursor))const;
   void change_list_cursor(sos_Bool)const;
protected:
   void check_impl_type(OBST_PARDECL(sos_Object_sos_Object_Mapping_impl))const;
public:
   void change(sos_Cstring,sos_Cstring)const;
   sos_Bool has_type(OBST_PARDECL(sos_Type))const;
   sos_Bool is_key(OBST_PARDECL(sos_Object))const;
   void remove(OBST_PARDECL(sos_Object))const;
   sos_Object get_key(OBST_PARDECL(sos_Cursor))const;
   sos_Bool move_cursor(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object))const;
   sos_Bool is_role1(OBST_PARDECL(sos_Object))const;
   sos_Bool to_succ(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
protected:
   static void local_initialize(OBST_PARDECL(sos_Object_sos_Object_Mapping));
   static sos_Int local_hash_value(OBST_PARDECL(sos_Object_sos_Object_Mapping));
private:
   sos_Object_sos_Object_Mapping_impl get_impl(OBST_NO_ARGS)const;
   void set_impl(OBST_PARDECL(sos_Object_sos_Object_Mapping_impl))const;
   agg_Impl get_impl_type(OBST_NO_ARGS)const;
   void set_impl_type(agg_Impl)const;
public:
   sos_Bool is_some(OBST_PARDECL(sos_Type))const;
   sos_Bool is_value(OBST_NO_ARGS)const;
};
OBST_TMPDEF(extern,sos_Object_sos_Object_Mapping,_sos_Object_sos_Object_Mapping_tmp)
#define _sos_Object_sos_Object_Mapping_type _agg__tp_[8]
#define sos_Object_sos_Object_Mapping_type _agg_tp_[8]
class sos_Object_sos_Object_Mapping_List: public obst_Root_class 
{  friend class _sos_Object_sos_Object_Mapping_List;
   const class _sos_Object_sos_Object_Mapping_List*_impl;
public :
   operator sos_Object(OBST_NO_ARGS) const;
   operator sos_Aggregate(OBST_NO_ARGS) const;
   operator sos_Object_sos_Object_Association(OBST_NO_ARGS) const;
   operator sos_Object_sos_Object_Mapping_impl(OBST_NO_ARGS) const;
   static sos_Object_sos_Object_Mapping_List make(const sos_Typed_id&);
   static sos_Object_sos_Object_Mapping_List make(const sos_Typed_id&_OBSThis,const _sos_Object_sos_Object_Mapping_List *_y){
         sos_Object_sos_Object_Mapping_List _x;_x._self=_OBSThis;_x._impl=_y;return _x;
   }
   static sos_Object_sos_Object_Mapping_List make(const obst_Root_class&);
   void destroy(OBST_NO_ARGS)const;
   sos_Int hash_value(OBST_NO_ARGS)const;
   sos_Object operator[](OBST_PARDECL(sos_Object))const;
   sos_Object get_info(OBST_PARDECL(sos_Cursor))const;
   void set_info(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object))const;
   sos_Bool is_role2(OBST_PARDECL(sos_Object))const;
   sos_Int card(OBST_NO_ARGS)const;
   sos_Cursor open_cursor(sos_Container =TEMP_CONTAINER)const;
   void close_cursor(OBST_PARDECL(sos_Cursor))const;
   sos_Cursor duplicate(OBST_PARDECL(sos_Cursor),sos_Container =TEMP_CONTAINER)const;
   sos_Bool to_last(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_pred(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
protected:
   static void local_assign(OBST_PARDECL(sos_Object_sos_Object_Mapping_List),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(sos_Object_sos_Object_Mapping_List),OBST_PARDECL(sos_Object),sos_Eq_kind);
private:
   sos_Offset get_first(OBST_NO_ARGS)const;
   void set_first(sos_Offset)const;
   void read_node(sos_Offset,sos_Object&,sos_Object&,sos_Offset&,sos_Offset&,sos_Int&)const;
public:
   void check_node_type(OBST_PARDECL(sos_Cursor))const;
   sos_Bool is_empty(OBST_NO_ARGS)const;
   sos_Bool isa(OBST_PARDECL(sos_Type))const;
   static sos_Object_sos_Object_Mapping_List create(sos_Container,sos_Bool =FALSE,sos_Bool =FALSE,sos_Bool =FALSE);
   static sos_Object_sos_Object_Mapping_List copy(OBST_PARDECL(sos_Object_sos_Object_Mapping_List),sos_Container);
   void assign(OBST_PARDECL(sos_Object))const;
   sos_Bool equal(OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   sos_Bool is_info(OBST_PARDECL(sos_Object))const;
   void insert(OBST_PARDECL(sos_Object),OBST_PARDECL(sos_Object))const;
   void insert_before(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object),OBST_PARDECL(sos_Object))const;
   sos_Int size(OBST_NO_ARGS)const;
   void clear(OBST_NO_ARGS)const;
protected:
   static void local_finalize(OBST_PARDECL(sos_Object_sos_Object_Mapping_List));
private:
   void set_prev(sos_Offset,sos_Offset)const;
   void remove_node(sos_Offset,sos_Int)const;
   void get_succ_pred(OBST_PARDECL(sos_Mapping_List_node),sos_Offset&,sos_Offset&)const;
protected:
   sos_Bool get_role1_based_on_equal(OBST_NO_ARGS)const;
   void set_role1_based_on_equal(sos_Bool)const;
   sos_Bool get_role2_based_on_equal(OBST_NO_ARGS)const;
   void set_role2_based_on_equal(sos_Bool)const;
public:
   sos_Bool like(OBST_PARDECL(sos_Object))const;
   sos_Bool get_list_cursor(OBST_NO_ARGS)const;
   void set_list_cursor(sos_Bool)const;
   sos_Type type(OBST_NO_ARGS)const;
   static sos_Object_sos_Object_Mapping_List clone(OBST_PARDECL(sos_Object_sos_Object_Mapping_List),sos_Container);
   void insert_after(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object),OBST_PARDECL(sos_Object))const;
   sos_Object get_role1(OBST_PARDECL(sos_Cursor))const;
   sos_Object get_role2(OBST_PARDECL(sos_Cursor))const;
   void remove_at(OBST_PARDECL(sos_Cursor))const;
   sos_Bool is_valid(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_first(OBST_PARDECL(sos_Cursor))const;
private:
   sos_Container get_key_default_cnt(OBST_NO_ARGS)const;
   void set_key_default_cnt(sos_Container)const;
   sos_Container get_info_default_cnt(OBST_NO_ARGS)const;
   void set_info_default_cnt(sos_Container)const;
   sos_Id get_info_default_type(OBST_NO_ARGS)const;
   void set_info_default_type(sos_Id)const;
   sos_Int get_size(OBST_NO_ARGS)const;
   void set_size(sos_Int)const;
public:
   void change(sos_Cstring,sos_Cstring)const;
   sos_Bool has_type(OBST_PARDECL(sos_Type))const;
   sos_Bool is_key(OBST_PARDECL(sos_Object))const;
   void remove(OBST_PARDECL(sos_Object))const;
   sos_Object get_key(OBST_PARDECL(sos_Cursor))const;
   sos_Bool move_cursor(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object))const;
   sos_Bool is_role1(OBST_PARDECL(sos_Object))const;
   sos_Bool to_succ(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
protected:
   static void local_initialize(OBST_PARDECL(sos_Object_sos_Object_Mapping_List));
   static sos_Int local_hash_value(OBST_PARDECL(sos_Object_sos_Object_Mapping_List));
private:
   sos_Offset get_last(OBST_NO_ARGS)const;
   void set_last(sos_Offset)const;
   sos_Id get_key_default_type(OBST_NO_ARGS)const;
   void set_key_default_type(sos_Id)const;
   sos_Int get_cardinality(OBST_NO_ARGS)const;
   void set_cardinality(sos_Int)const;
   sos_Offset create_node(OBST_PARDECL(sos_Object),OBST_PARDECL(sos_Object),sos_Offset,sos_Offset)const;
   void set_next(sos_Offset,sos_Offset)const;
public:
   sos_Bool is_some(OBST_PARDECL(sos_Type))const;
   sos_Bool is_value(OBST_NO_ARGS)const;
};
OBST_TMPDEF(extern,sos_Object_sos_Object_Mapping_List,_sos_Object_sos_Object_Mapping_List_tmp)
#define _sos_Object_sos_Object_Mapping_List_type _agg__tp_[9]
#define sos_Object_sos_Object_Mapping_List_type _agg_tp_[9]
class sos_Object_sos_Object_Mapping_Hash: public obst_Root_class 
{  friend class _sos_Object_sos_Object_Mapping_Hash;
   const class _sos_Object_sos_Object_Mapping_Hash*_impl;
public :
   operator sos_Object(OBST_NO_ARGS) const;
   operator sos_Aggregate(OBST_NO_ARGS) const;
   operator sos_Object_sos_Object_Association(OBST_NO_ARGS) const;
   operator sos_Object_sos_Object_Mapping_impl(OBST_NO_ARGS) const;
   static sos_Object_sos_Object_Mapping_Hash make(const sos_Typed_id&);
   static sos_Object_sos_Object_Mapping_Hash make(const sos_Typed_id&_OBSThis,const _sos_Object_sos_Object_Mapping_Hash *_y){
         sos_Object_sos_Object_Mapping_Hash _x;_x._self=_OBSThis;_x._impl=_y;return _x;
   }
   static sos_Object_sos_Object_Mapping_Hash make(const obst_Root_class&);
   void destroy(OBST_NO_ARGS)const;
   sos_Int hash_value(OBST_NO_ARGS)const;
   sos_Object operator[](OBST_PARDECL(sos_Object))const;
   sos_Object get_info(OBST_PARDECL(sos_Cursor))const;
   void set_info(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object))const;
   sos_Bool is_role2(OBST_PARDECL(sos_Object))const;
   sos_Int card(OBST_NO_ARGS)const;
   sos_Cursor open_cursor(sos_Container =TEMP_CONTAINER)const;
   void close_cursor(OBST_PARDECL(sos_Cursor))const;
   sos_Cursor duplicate(OBST_PARDECL(sos_Cursor),sos_Container =TEMP_CONTAINER)const;
   sos_Bool to_last(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_pred(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
protected:
   static void local_assign(OBST_PARDECL(sos_Object_sos_Object_Mapping_Hash),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(sos_Object_sos_Object_Mapping_Hash),OBST_PARDECL(sos_Object),sos_Eq_kind);
private:
   sos_Object remove_from_page_list(sos_Container,sos_Bool,sos_Bool,sos_Offset,sos_Int,OBST_PARDECL(sos_Object))const;
   void split_page(sos_Container,sos_Bool,sos_Offset,sos_Char,sos_Int,sos_Int)const;
public:
   void check_node_type(OBST_PARDECL(sos_Cursor))const;
   sos_Bool is_empty(OBST_NO_ARGS)const;
   sos_Bool isa(OBST_PARDECL(sos_Type))const;
   static sos_Object_sos_Object_Mapping_Hash create(sos_Container,sos_Bool =FALSE,sos_Bool =FALSE,sos_Bool =FALSE);
   static sos_Object_sos_Object_Mapping_Hash copy(OBST_PARDECL(sos_Object_sos_Object_Mapping_Hash),sos_Container);
   void assign(OBST_PARDECL(sos_Object))const;
   sos_Bool equal(OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   sos_Bool is_info(OBST_PARDECL(sos_Object))const;
   void clear(OBST_NO_ARGS)const;
protected:
   static void local_finalize(OBST_PARDECL(sos_Object_sos_Object_Mapping_Hash));
private:
   sos_Object get_last_object(OBST_NO_ARGS)const;
   void set_last_object(OBST_PARDECL(sos_Object))const;
   sos_Int get_no_of_pages(OBST_NO_ARGS)const;
   void set_no_of_pages(sos_Int)const;
   sos_Int get_global_depth(OBST_NO_ARGS)const;
   void set_global_depth(sos_Int)const;
   void insert_in_page_list(sos_Container,sos_Bool,sos_Bool,sos_Offset,sos_Int,OBST_PARDECL(sos_Object),OBST_PARDECL(sos_Object),OBST_PARDECL(sos_Object),OBST_PARDECL(sos_Object))const;
   void write_succ_pred(sos_Container,sos_Bool,sos_Bool,OBST_PARDECL(sos_Object),sos_Bool,OBST_PARDECL(sos_Object))const;
public:
   sos_Bool get_list_cursor(OBST_NO_ARGS)const;
   void set_list_cursor(sos_Bool)const;
   static sos_Object_sos_Object_Mapping_Hash clone(OBST_PARDECL(sos_Object_sos_Object_Mapping_Hash),sos_Container);
   void insert_after(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object),OBST_PARDECL(sos_Object))const;
   sos_Object get_role1(OBST_PARDECL(sos_Cursor))const;
   sos_Object get_role2(OBST_PARDECL(sos_Cursor))const;
   void remove_at(OBST_PARDECL(sos_Cursor))const;
   sos_Bool is_valid(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_first(OBST_PARDECL(sos_Cursor))const;
private:
   sos_Object get_first_object(OBST_NO_ARGS)const;
   void set_first_object(OBST_PARDECL(sos_Object))const;
   sos_Int get_no_of_page_lists(OBST_NO_ARGS)const;
   void set_no_of_page_lists(sos_Int)const;
   void init_table(OBST_NO_ARGS)const;
   sos_Object search_succ_pred(OBST_PARDECL(sos_Object),sos_Int)const;
public:
   void change(sos_Cstring,sos_Cstring)const;
   sos_Bool has_type(OBST_PARDECL(sos_Type))const;
   sos_Bool is_key(OBST_PARDECL(sos_Object))const;
   void remove(OBST_PARDECL(sos_Object))const;
   sos_Object get_key(OBST_PARDECL(sos_Cursor))const;
   sos_Bool move_cursor(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object))const;
   sos_Bool is_role1(OBST_PARDECL(sos_Object))const;
   sos_Bool to_succ(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
protected:
   static void local_initialize(OBST_PARDECL(sos_Object_sos_Object_Mapping_Hash));
   static sos_Int local_hash_value(OBST_PARDECL(sos_Object_sos_Object_Mapping_Hash));
private:
   sos_Int get_cardinality(OBST_NO_ARGS)const;
   void set_cardinality(sos_Int)const;
   sos_Int get_ht_entries(OBST_NO_ARGS)const;
   void set_ht_entries(sos_Int)const;
   sos_Bool assemble_page(sos_Offset,sos_Char,sos_Int)const;
public:
   sos_Bool is_some(OBST_PARDECL(sos_Type))const;
   sos_Bool is_value(OBST_NO_ARGS)const;
   void insert(OBST_PARDECL(sos_Object),OBST_PARDECL(sos_Object))const;
   void insert_before(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object),OBST_PARDECL(sos_Object))const;
   sos_Int size(OBST_NO_ARGS)const;
private:
   sos_Offset get_no_of_pages_offset(OBST_NO_ARGS)const;
   void set_no_of_pages_offset(sos_Offset)const;
   sos_Int get_ht_offset(OBST_NO_ARGS)const;
   void set_ht_offset(sos_Int)const;
   void increase_hash_table(OBST_NO_ARGS)const;
   void decrease_hash_table(OBST_NO_ARGS)const;
   void insert_in_list(OBST_PARDECL(sos_Object),OBST_PARDECL(sos_Object),OBST_PARDECL(sos_Object),OBST_PARDECL(sos_Object))const;
protected:
   sos_Bool get_role1_based_on_equal(OBST_NO_ARGS)const;
   void set_role1_based_on_equal(sos_Bool)const;
   sos_Bool get_role2_based_on_equal(OBST_NO_ARGS)const;
   void set_role2_based_on_equal(sos_Bool)const;
public:
   sos_Bool like(OBST_PARDECL(sos_Object))const;
   sos_Type type(OBST_NO_ARGS)const;
};
OBST_TMPDEF(extern,sos_Object_sos_Object_Mapping_Hash,_sos_Object_sos_Object_Mapping_Hash_tmp)
#define _sos_Object_sos_Object_Mapping_Hash_type _agg__tp_[10]
#define sos_Object_sos_Object_Mapping_Hash_type _agg_tp_[10]
class sos_Object_Bag: public obst_Root_class 
{  friend class _sos_Object_Bag;
   const class _sos_Object_Bag*_impl;
public :
   operator sos_Object(OBST_NO_ARGS) const;
   operator sos_Aggregate(OBST_NO_ARGS) const;
   operator sos_Object_Collection(OBST_NO_ARGS) const;
   static sos_Object_Bag make(const sos_Typed_id&);
   static sos_Object_Bag make(const sos_Typed_id&_OBSThis,const _sos_Object_Bag *_y){
         sos_Object_Bag _x;_x._self=_OBSThis;_x._impl=_y;return _x;
   }
   static sos_Object_Bag make(const obst_Root_class&);
   void destroy(OBST_NO_ARGS)const;
   sos_Int hash_value(OBST_NO_ARGS)const;
   void operator+=(OBST_PARDECL(sos_Object_Bag))const;
   void operator-=(OBST_PARDECL(sos_Object_Bag))const;
   void operator*=(OBST_PARDECL(sos_Object_Bag))const;
   sos_Bool operator<(OBST_PARDECL(sos_Object_Bag))const;
   sos_Bool operator<=(OBST_PARDECL(sos_Object_Bag))const;
   sos_Bool operator>(OBST_PARDECL(sos_Object_Bag))const;
   sos_Bool operator>=(OBST_PARDECL(sos_Object_Bag))const;
   void max_union(OBST_PARDECL(sos_Object_Bag))const;
   sos_Int entity_occurs(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_diff_succ(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
   sos_Bool is_element(OBST_PARDECL(sos_Object))const;
   sos_Object get(OBST_PARDECL(sos_Cursor))const;
   sos_Int card(OBST_NO_ARGS)const;
   sos_Cursor open_cursor(sos_Container =TEMP_CONTAINER)const;
   void close_cursor(OBST_PARDECL(sos_Cursor))const;
   sos_Cursor duplicate(OBST_PARDECL(sos_Cursor),sos_Container =TEMP_CONTAINER)const;
   sos_Bool to_last(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_pred(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
protected:
   static void local_assign(OBST_PARDECL(sos_Object_Bag),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(sos_Object_Bag),OBST_PARDECL(sos_Object),sos_Eq_kind);
public:
   sos_Bool is_empty(OBST_NO_ARGS)const;
   sos_Bool isa(OBST_PARDECL(sos_Type))const;
   static sos_Object_Bag create(sos_Container,sos_Bool =FALSE,sos_Bool =FALSE,agg_Impl =AGG_AUTOMATIC);
   static sos_Object_Bag copy(OBST_PARDECL(sos_Object_Bag),sos_Container);
   void assign(OBST_PARDECL(sos_Object))const;
   sos_Bool equal(OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   sos_Int insert(OBST_PARDECL(sos_Object))const;
   void eliminate(OBST_PARDECL(sos_Object))const;
   void clear(OBST_NO_ARGS)const;
   void change_impl_type(agg_Impl)const;
protected:
   static void local_finalize(OBST_PARDECL(sos_Object_Bag));
   sos_Bool get_based_on_equal(OBST_NO_ARGS)const;
   void set_based_on_equal(sos_Bool)const;
public:
   sos_Bool like(OBST_PARDECL(sos_Object))const;
   sos_Bool get_list_cursor(OBST_NO_ARGS)const;
   void set_list_cursor(sos_Bool)const;
   sos_Type type(OBST_NO_ARGS)const;
   sos_Int size(OBST_NO_ARGS)const;
   static sos_Object_Bag clone(OBST_PARDECL(sos_Object_Bag),sos_Container);
   void remove_at(OBST_PARDECL(sos_Cursor))const;
   sos_Bool is_valid(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_first(OBST_PARDECL(sos_Cursor))const;
   void change_list_cursor(sos_Bool)const;
private:
   void search_succ_pred(OBST_PARDECL(sos_Bag_node),sos_Int,sos_Object&,sos_Int&,sos_Int&)const;
   sos_Int get_no_of_elements(OBST_PARDECL(sos_Object_sos_Int_Mapping),OBST_PARDECL(sos_Object))const;
   sos_Int set_no_of_elements(OBST_PARDECL(sos_Object_sos_Int_Mapping),OBST_PARDECL(sos_Object),sos_Int,sos_Int)const;
public:
   void change(sos_Cstring,sos_Cstring)const;
   sos_Bool has_type(OBST_PARDECL(sos_Type))const;
   sos_Int remove(OBST_PARDECL(sos_Object))const;
   sos_Int occurrences(OBST_PARDECL(sos_Object))const;
   sos_Bool to_diff_pred(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
   sos_Bool to_succ(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
protected:
   static void local_initialize(OBST_PARDECL(sos_Object_Bag));
   static sos_Int local_hash_value(OBST_PARDECL(sos_Object_Bag));
private:
   sos_Int get_cardinality(OBST_NO_ARGS)const;
   void set_cardinality(sos_Int)const;
   sos_Object_sos_Int_Mapping get_m(OBST_NO_ARGS)const;
   void set_m(OBST_PARDECL(sos_Object_sos_Int_Mapping))const;
   void write_current(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object),sos_Int,sos_Int)const;
public:
   agg_Impl get_impl_type(OBST_NO_ARGS)const;
private:
   void set_impl_type(agg_Impl)const;
public:
   sos_Bool is_some(OBST_PARDECL(sos_Type))const;
   sos_Bool is_value(OBST_NO_ARGS)const;
};
OBST_TMPDEF(extern,sos_Object_Bag,_sos_Object_Bag_tmp)
#define _sos_Object_Bag_type _agg__tp_[11]
#define sos_Object_Bag_type _agg_tp_[11]
class sos_Object_sos_Int_Mapping: public obst_Root_class 
{  friend class _sos_Object_sos_Object_Mapping;
   const class _sos_Object_sos_Object_Mapping*_impl;
public :
   operator sos_Object(OBST_NO_ARGS) const;
   operator sos_Aggregate(OBST_NO_ARGS) const;
   operator sos_Object_sos_Int_Association(OBST_NO_ARGS) const;
   operator sos_Object_sos_Object_Association(OBST_NO_ARGS) const;
   operator sos_Object_sos_Object_Mapping(OBST_NO_ARGS) const;
   static sos_Object_sos_Int_Mapping make(const sos_Typed_id&);
   static sos_Object_sos_Int_Mapping make(const sos_Typed_id&_OBSThis,const _sos_Object_sos_Object_Mapping *_y){
         sos_Object_sos_Int_Mapping _x;_x._self=_OBSThis;_x._impl=_y;return _x;
   }
   static sos_Object_sos_Int_Mapping make(const obst_Root_class&);
   void destroy(OBST_NO_ARGS)const;
   sos_Int hash_value(OBST_NO_ARGS)const;
   sos_Int operator[](OBST_PARDECL(sos_Object))const;
   sos_Int get_info(OBST_PARDECL(sos_Cursor))const;
   void set_info(OBST_PARDECL(sos_Cursor),sos_Int)const;
   sos_Bool is_role2(sos_Int)const;
   sos_Int card(OBST_NO_ARGS)const;
   sos_Cursor open_cursor(sos_Container =TEMP_CONTAINER)const;
   void close_cursor(OBST_PARDECL(sos_Cursor))const;
   sos_Cursor duplicate(OBST_PARDECL(sos_Cursor),sos_Container =TEMP_CONTAINER)const;
   sos_Bool to_last(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_pred(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
   sos_Bool is_empty(OBST_NO_ARGS)const;
   sos_Bool isa(OBST_PARDECL(sos_Type))const;
   static sos_Object_sos_Int_Mapping create(sos_Container,sos_Bool =FALSE,sos_Bool =FALSE,sos_Bool =FALSE,agg_Impl =AGG_AUTOMATIC);
   static sos_Object_sos_Int_Mapping copy(OBST_PARDECL(sos_Object_sos_Int_Mapping),sos_Container);
   void assign(OBST_PARDECL(sos_Object))const;
   sos_Bool equal(OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   sos_Bool is_info(sos_Int)const;
   void insert(OBST_PARDECL(sos_Object),sos_Int)const;
   void insert_before(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object),sos_Int)const;
   sos_Int size(OBST_NO_ARGS)const;
   void clear(OBST_NO_ARGS)const;
   void change_impl_type(agg_Impl)const;
   sos_Bool like(OBST_PARDECL(sos_Object))const;
   sos_Bool get_list_cursor(OBST_NO_ARGS)const;
   void set_list_cursor(sos_Bool)const;
   sos_Type type(OBST_NO_ARGS)const;
   static sos_Object_sos_Int_Mapping clone(OBST_PARDECL(sos_Object_sos_Int_Mapping),sos_Container);
   void insert_after(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object),sos_Int)const;
   sos_Object get_role1(OBST_PARDECL(sos_Cursor))const;
   sos_Int get_role2(OBST_PARDECL(sos_Cursor))const;
   void remove_at(OBST_PARDECL(sos_Cursor))const;
   sos_Bool is_valid(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_first(OBST_PARDECL(sos_Cursor))const;
   void change_list_cursor(sos_Bool)const;
   void change(sos_Cstring,sos_Cstring)const;
   sos_Bool has_type(OBST_PARDECL(sos_Type))const;
   sos_Bool is_key(OBST_PARDECL(sos_Object))const;
   void remove(OBST_PARDECL(sos_Object))const;
   sos_Object get_key(OBST_PARDECL(sos_Cursor))const;
   sos_Bool move_cursor(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_Object))const;
   sos_Bool is_role1(OBST_PARDECL(sos_Object))const;
   sos_Bool to_succ(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
   sos_Bool is_some(OBST_PARDECL(sos_Type))const;
   sos_Bool is_value(OBST_NO_ARGS)const;
};
OBST_TMPDEF(extern,sos_Object_sos_Int_Mapping,_sos_Object_sos_Int_Mapping_tmp)
#define _sos_Object_sos_Int_Mapping_type _agg__tp_[12]
#define sos_Object_sos_Int_Mapping_type _agg_tp_[12]
class sos_Object_sos_Int_Association: public obst_Root_class 
{  friend class _sos_Object_sos_Object_Association;
   const class _sos_Object_sos_Object_Association*_impl;
public :
   operator sos_Object(OBST_NO_ARGS) const;
   operator sos_Aggregate(OBST_NO_ARGS) const;
   operator sos_Object_sos_Object_Association(OBST_NO_ARGS) const;
   static sos_Object_sos_Int_Association make(const sos_Typed_id&);
   static sos_Object_sos_Int_Association make(const sos_Typed_id&_OBSThis,const _sos_Object_sos_Object_Association *_y){
         sos_Object_sos_Int_Association _x;_x._self=_OBSThis;_x._impl=_y;return _x;
   }
   static sos_Object_sos_Int_Association make(const obst_Root_class&);
   static sos_Object_sos_Int_Association clone(OBST_PARDECL(sos_Object_sos_Int_Association),sos_Container);
   void destroy(OBST_NO_ARGS)const;
   sos_Int hash_value(OBST_NO_ARGS)const;
   sos_Bool is_role2(sos_Int)const;
   sos_Object get_role1(OBST_PARDECL(sos_Cursor))const;
   sos_Int get_role2(OBST_PARDECL(sos_Cursor))const;
   void change(sos_Cstring,sos_Cstring)const;
   sos_Bool is_empty(OBST_NO_ARGS)const;
   sos_Int card(OBST_NO_ARGS)const;
   sos_Cursor open_cursor(sos_Container =TEMP_CONTAINER)const;
   void close_cursor(OBST_PARDECL(sos_Cursor))const;
   sos_Cursor duplicate(OBST_PARDECL(sos_Cursor),sos_Container =TEMP_CONTAINER)const;
   sos_Bool is_valid(OBST_PARDECL(sos_Cursor))const;
   void remove_at(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_first(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_last(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_pred(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
   sos_Bool has_type(OBST_PARDECL(sos_Type))const;
   sos_Bool isa(OBST_PARDECL(sos_Type))const;
   void assign(OBST_PARDECL(sos_Object))const;
   sos_Bool equal(OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   sos_Bool is_role1(OBST_PARDECL(sos_Object))const;
   sos_Bool like(OBST_PARDECL(sos_Object))const;
   void clear(OBST_NO_ARGS)const;
   sos_Bool to_succ(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
   sos_Bool get_list_cursor(OBST_NO_ARGS)const;
   void set_list_cursor(sos_Bool)const;
   sos_Type type(OBST_NO_ARGS)const;
   sos_Bool is_some(OBST_PARDECL(sos_Type))const;
   sos_Bool is_value(OBST_NO_ARGS)const;
   sos_Int size(OBST_NO_ARGS)const;
};
OBST_TMPDEF(extern,sos_Object_sos_Int_Association,_sos_Object_sos_Int_Association_tmp)
#define _sos_Object_sos_Int_Association_type _agg__tp_[13]
#define sos_Object_sos_Int_Association_type _agg_tp_[13]
class sos_Object_Set: public obst_Root_class 
{  friend class _sos_Object_Set;
   const class _sos_Object_Set*_impl;
public :
   operator sos_Object(OBST_NO_ARGS) const;
   operator sos_Aggregate(OBST_NO_ARGS) const;
   operator sos_Object_Collection(OBST_NO_ARGS) const;
   static sos_Object_Set make(const sos_Typed_id&);
   static sos_Object_Set make(const sos_Typed_id&_OBSThis,const _sos_Object_Set *_y){
         sos_Object_Set _x;_x._self=_OBSThis;_x._impl=_y;return _x;
   }
   static sos_Object_Set make(const obst_Root_class&);
   void destroy(OBST_NO_ARGS)const;
   sos_Int hash_value(OBST_NO_ARGS)const;
   void operator+=(OBST_PARDECL(sos_Object_Set))const;
   void operator-=(OBST_PARDECL(sos_Object_Set))const;
   void operator*=(OBST_PARDECL(sos_Object_Set))const;
   sos_Bool operator<(OBST_PARDECL(sos_Object_Set))const;
   sos_Bool operator<=(OBST_PARDECL(sos_Object_Set))const;
   sos_Bool operator>(OBST_PARDECL(sos_Object_Set))const;
   sos_Bool operator>=(OBST_PARDECL(sos_Object_Set))const;
   sos_Bool is_element(OBST_PARDECL(sos_Object))const;
   sos_Object get(OBST_PARDECL(sos_Cursor))const;
   sos_Int card(OBST_NO_ARGS)const;
   sos_Cursor open_cursor(sos_Container =TEMP_CONTAINER)const;
   void close_cursor(OBST_PARDECL(sos_Cursor))const;
   sos_Cursor duplicate(OBST_PARDECL(sos_Cursor),sos_Container =TEMP_CONTAINER)const;
   sos_Bool to_last(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_pred(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
protected:
   static void local_assign(OBST_PARDECL(sos_Object_Set),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(sos_Object_Set),OBST_PARDECL(sos_Object),sos_Eq_kind);
public:
   sos_Bool is_empty(OBST_NO_ARGS)const;
   sos_Bool isa(OBST_PARDECL(sos_Type))const;
   static sos_Object_Set create(sos_Container,sos_Bool =FALSE,sos_Bool =FALSE,agg_Impl =AGG_AUTOMATIC);
   static sos_Object_Set copy(OBST_PARDECL(sos_Object_Set),sos_Container);
   void assign(OBST_PARDECL(sos_Object))const;
   sos_Bool equal(OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   void insert(OBST_PARDECL(sos_Object))const;
   void clear(OBST_NO_ARGS)const;
   void change_impl_type(agg_Impl)const;
protected:
   static void local_finalize(OBST_PARDECL(sos_Object_Set));
   sos_Bool get_based_on_equal(OBST_NO_ARGS)const;
   void set_based_on_equal(sos_Bool)const;
public:
   sos_Bool like(OBST_PARDECL(sos_Object))const;
   sos_Bool get_list_cursor(OBST_NO_ARGS)const;
   void set_list_cursor(sos_Bool)const;
   sos_Type type(OBST_NO_ARGS)const;
   sos_Int size(OBST_NO_ARGS)const;
   static sos_Object_Set clone(OBST_PARDECL(sos_Object_Set),sos_Container);
   void remove_at(OBST_PARDECL(sos_Cursor))const;
   sos_Bool is_valid(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_first(OBST_PARDECL(sos_Cursor))const;
   void change_list_cursor(sos_Bool)const;
   void change(sos_Cstring,sos_Cstring)const;
   sos_Bool has_type(OBST_PARDECL(sos_Type))const;
   void remove(OBST_PARDECL(sos_Object))const;
   sos_Bool to_succ(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
protected:
   static void local_initialize(OBST_PARDECL(sos_Object_Set));
   static sos_Int local_hash_value(OBST_PARDECL(sos_Object_Set));
private:
   sos_Object_sos_Object_Mapping get_m(OBST_NO_ARGS)const;
   void set_m(OBST_PARDECL(sos_Object_sos_Object_Mapping))const;
public:
   agg_Impl get_impl_type(OBST_NO_ARGS)const;
private:
   void set_impl_type(agg_Impl)const;
public:
   sos_Bool is_some(OBST_PARDECL(sos_Type))const;
   sos_Bool is_value(OBST_NO_ARGS)const;
};
OBST_TMPDEF(extern,sos_Object_Set,_sos_Object_Set_tmp)
#define _sos_Object_Set_type _agg__tp_[14]
#define sos_Object_Set_type _agg_tp_[14]
class sos_Node: public obst_Root_class 
{  friend class _sos_Node;
   const class _sos_Node*_impl;
public :
   operator sos_Object(OBST_NO_ARGS) const;
   static sos_Node make(const sos_Typed_id&);
   static sos_Node make(const sos_Typed_id&_OBSThis,const _sos_Node *_y){
         sos_Node _x;_x._self=_OBSThis;_x._impl=_y;return _x;
   }
   static sos_Node make(const obst_Root_class&);
   sos_Bool like(OBST_PARDECL(sos_Object))const;
   static sos_Node clone(OBST_PARDECL(sos_Node),sos_Container);
   void destroy(OBST_NO_ARGS)const;
   void assign(OBST_PARDECL(sos_Object))const;
   sos_Bool equal(OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   sos_Int hash_value(OBST_NO_ARGS)const;
   sos_Bool get_list_cursor(OBST_NO_ARGS)const;
   void set_list_cursor(sos_Bool)const;
   void check_list_cursor(OBST_PARDECL(sos_Aggregate))const;
   sos_Type type(OBST_NO_ARGS)const;
   sos_Bool has_type(OBST_PARDECL(sos_Type))const;
   sos_Bool isa(OBST_PARDECL(sos_Type))const;
   sos_Bool is_some(OBST_PARDECL(sos_Type))const;
   sos_Bool is_value(OBST_NO_ARGS)const;
   sos_Int size(OBST_NO_ARGS)const;
protected:
   static void local_assign(OBST_PARDECL(sos_Node),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(sos_Node),OBST_PARDECL(sos_Object),sos_Eq_kind);
   static sos_Int local_hash_value(OBST_PARDECL(sos_Node));
};
OBST_TMPDEF(extern,sos_Node,_sos_Node_tmp)
#define _sos_Node_type _agg__tp_[15]
#define sos_Node_type _agg_tp_[15]
class sos_Array_node: public obst_Root_class 
{  friend class _sos_Array_node;
   const class _sos_Array_node*_impl;
public :
   operator sos_Object(OBST_NO_ARGS) const;
   operator sos_Node(OBST_NO_ARGS) const;
   friend class _sos_Object_Array;
   static sos_Array_node make(const sos_Typed_id&);
   static sos_Array_node make(const sos_Typed_id&_OBSThis,const _sos_Array_node *_y){
         sos_Array_node _x;_x._self=_OBSThis;_x._impl=_y;return _x;
   }
   static sos_Array_node make(const obst_Root_class&);
   static sos_Array_node create(sos_Container,sos_Bool);
   static sos_Array_node copy(OBST_PARDECL(sos_Array_node),sos_Container);
   static sos_Array_node clone(OBST_PARDECL(sos_Array_node),sos_Container);
   void destroy(OBST_NO_ARGS)const;
   void assign(OBST_PARDECL(sos_Object))const;
   sos_Bool equal(OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   sos_Int hash_value(OBST_NO_ARGS)const;
private:
   sos_Int get_index(OBST_NO_ARGS)const;
   void set_index(sos_Int)const;
public:
   sos_Bool like(OBST_PARDECL(sos_Object))const;
   sos_Bool get_list_cursor(OBST_NO_ARGS)const;
   void set_list_cursor(sos_Bool)const;
   void check_list_cursor(OBST_PARDECL(sos_Aggregate))const;
   sos_Type type(OBST_NO_ARGS)const;
   sos_Bool has_type(OBST_PARDECL(sos_Type))const;
   sos_Bool isa(OBST_PARDECL(sos_Type))const;
   sos_Bool is_some(OBST_PARDECL(sos_Type))const;
   sos_Bool is_value(OBST_NO_ARGS)const;
   sos_Int size(OBST_NO_ARGS)const;
protected:
   static void local_assign(OBST_PARDECL(sos_Array_node),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(sos_Array_node),OBST_PARDECL(sos_Object),sos_Eq_kind);
   static sos_Int local_hash_value(OBST_PARDECL(sos_Array_node));
};
OBST_TMPDEF(extern,sos_Array_node,_sos_Array_node_tmp)
#define _sos_Array_node_type _agg__tp_[16]
#define sos_Array_node_type _agg_tp_[16]
class sos_List_node: public obst_Root_class 
{  friend class _sos_List_node;
   const class _sos_List_node*_impl;
public :
   operator sos_Object(OBST_NO_ARGS) const;
   operator sos_Node(OBST_NO_ARGS) const;
   friend class _sos_Object_List;
   static sos_List_node make(const sos_Typed_id&);
   static sos_List_node make(const sos_Typed_id&_OBSThis,const _sos_List_node *_y){
         sos_List_node _x;_x._self=_OBSThis;_x._impl=_y;return _x;
   }
   static sos_List_node make(const obst_Root_class&);
   static sos_List_node clone(OBST_PARDECL(sos_List_node),sos_Container);
   void destroy(OBST_NO_ARGS)const;
   sos_Int hash_value(OBST_NO_ARGS)const;
private:
   sos_Offset get_offset(OBST_NO_ARGS)const;
   void set_offset(sos_Offset)const;
public:
   void check_list_cursor(OBST_PARDECL(sos_Aggregate))const;
   sos_Bool has_type(OBST_PARDECL(sos_Type))const;
   sos_Bool isa(OBST_PARDECL(sos_Type))const;
protected:
   static void local_assign(OBST_PARDECL(sos_List_node),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(sos_List_node),OBST_PARDECL(sos_Object),sos_Eq_kind);
public:
   static sos_List_node create(sos_Container,sos_Bool);
   static sos_List_node copy(OBST_PARDECL(sos_List_node),sos_Container);
   void assign(OBST_PARDECL(sos_Object))const;
   sos_Bool equal(OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
private:
   sos_Offset get_prev(OBST_NO_ARGS)const;
   void set_prev(sos_Offset)const;
   sos_Offset get_next(OBST_NO_ARGS)const;
   void set_next(sos_Offset)const;
   sos_Object get_entry(OBST_NO_ARGS)const;
   void set_entry(OBST_PARDECL(sos_Object))const;
public:
   sos_Bool like(OBST_PARDECL(sos_Object))const;
   sos_Bool get_list_cursor(OBST_NO_ARGS)const;
   void set_list_cursor(sos_Bool)const;
   sos_Type type(OBST_NO_ARGS)const;
   sos_Bool is_some(OBST_PARDECL(sos_Type))const;
   sos_Bool is_value(OBST_NO_ARGS)const;
   sos_Int size(OBST_NO_ARGS)const;
protected:
   static sos_Int local_hash_value(OBST_PARDECL(sos_List_node));
};
OBST_TMPDEF(extern,sos_List_node,_sos_List_node_tmp)
#define _sos_List_node_type _agg__tp_[17]
#define sos_List_node_type _agg_tp_[17]
class sos_Mapping_node: public obst_Root_class 
{  friend class _sos_Mapping_node;
   const class _sos_Mapping_node*_impl;
public :
   operator sos_Object(OBST_NO_ARGS) const;
   operator sos_Node(OBST_NO_ARGS) const;
   static sos_Mapping_node make(const sos_Typed_id&);
   static sos_Mapping_node make(const sos_Typed_id&_OBSThis,const _sos_Mapping_node *_y){
         sos_Mapping_node _x;_x._self=_OBSThis;_x._impl=_y;return _x;
   }
   static sos_Mapping_node make(const obst_Root_class&);
   static sos_Mapping_node clone(OBST_PARDECL(sos_Mapping_node),sos_Container);
   void destroy(OBST_NO_ARGS)const;
   sos_Int hash_value(OBST_NO_ARGS)const;
   sos_Object get_info(OBST_NO_ARGS)const;
   void set_info(OBST_PARDECL(sos_Object))const;
   void check_list_cursor(OBST_PARDECL(sos_Aggregate))const;
   sos_Bool has_type(OBST_PARDECL(sos_Type))const;
   sos_Bool isa(OBST_PARDECL(sos_Type))const;
protected:
   static void local_assign(OBST_PARDECL(sos_Mapping_node),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(sos_Mapping_node),OBST_PARDECL(sos_Object),sos_Eq_kind);
public:
   static sos_Mapping_node create(sos_Container,sos_Bool);
   static sos_Mapping_node copy(OBST_PARDECL(sos_Mapping_node),sos_Container);
   void assign(OBST_PARDECL(sos_Object))const;
   sos_Bool equal(OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   sos_Object get_key(OBST_NO_ARGS)const;
   void set_key(OBST_PARDECL(sos_Object))const;
   sos_Bool like(OBST_PARDECL(sos_Object))const;
   sos_Bool get_list_cursor(OBST_NO_ARGS)const;
   void set_list_cursor(sos_Bool)const;
   sos_Type type(OBST_NO_ARGS)const;
   sos_Bool is_some(OBST_PARDECL(sos_Type))const;
   sos_Bool is_value(OBST_NO_ARGS)const;
   sos_Int size(OBST_NO_ARGS)const;
protected:
   static sos_Int local_hash_value(OBST_PARDECL(sos_Mapping_node));
};
OBST_TMPDEF(extern,sos_Mapping_node,_sos_Mapping_node_tmp)
#define _sos_Mapping_node_type _agg__tp_[18]
#define sos_Mapping_node_type _agg_tp_[18]
class sos_Mapping_List_node: public obst_Root_class 
{  friend class _sos_Mapping_List_node;
   const class _sos_Mapping_List_node*_impl;
public :
   operator sos_Object(OBST_NO_ARGS) const;
   operator sos_Node(OBST_NO_ARGS) const;
   operator sos_Mapping_node(OBST_NO_ARGS) const;
   friend class _sos_Object_sos_Object_Mapping_List;
   static sos_Mapping_List_node make(const sos_Typed_id&);
   static sos_Mapping_List_node make(const sos_Typed_id&_OBSThis,const _sos_Mapping_List_node *_y){
         sos_Mapping_List_node _x;_x._self=_OBSThis;_x._impl=_y;return _x;
   }
   static sos_Mapping_List_node make(const obst_Root_class&);
   static sos_Mapping_List_node clone(OBST_PARDECL(sos_Mapping_List_node),sos_Container);
   void destroy(OBST_NO_ARGS)const;
   sos_Int hash_value(OBST_NO_ARGS)const;
private:
   sos_Offset get_offset(OBST_NO_ARGS)const;
   void set_offset(sos_Offset)const;
public:
   sos_Object get_info(OBST_NO_ARGS)const;
   void set_info(OBST_PARDECL(sos_Object))const;
   void check_list_cursor(OBST_PARDECL(sos_Aggregate))const;
   sos_Bool has_type(OBST_PARDECL(sos_Type))const;
   sos_Bool isa(OBST_PARDECL(sos_Type))const;
protected:
   static void local_assign(OBST_PARDECL(sos_Mapping_List_node),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(sos_Mapping_List_node),OBST_PARDECL(sos_Object),sos_Eq_kind);
public:
   static sos_Mapping_List_node create(sos_Container,sos_Bool);
   static sos_Mapping_List_node copy(OBST_PARDECL(sos_Mapping_List_node),sos_Container);
   void assign(OBST_PARDECL(sos_Object))const;
   sos_Bool equal(OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
private:
   sos_Offset get_prev(OBST_NO_ARGS)const;
   void set_prev(sos_Offset)const;
   sos_Offset get_next(OBST_NO_ARGS)const;
   void set_next(sos_Offset)const;
public:
   sos_Object get_key(OBST_NO_ARGS)const;
   void set_key(OBST_PARDECL(sos_Object))const;
   sos_Bool like(OBST_PARDECL(sos_Object))const;
   sos_Bool get_list_cursor(OBST_NO_ARGS)const;
   void set_list_cursor(sos_Bool)const;
   sos_Type type(OBST_NO_ARGS)const;
   sos_Bool is_some(OBST_PARDECL(sos_Type))const;
   sos_Bool is_value(OBST_NO_ARGS)const;
   sos_Int size(OBST_NO_ARGS)const;
protected:
   static sos_Int local_hash_value(OBST_PARDECL(sos_Mapping_List_node));
};
OBST_TMPDEF(extern,sos_Mapping_List_node,_sos_Mapping_List_node_tmp)
#define _sos_Mapping_List_node_type _agg__tp_[19]
#define sos_Mapping_List_node_type _agg_tp_[19]
class sos_Bag_node: public obst_Root_class 
{  friend class _sos_Bag_node;
   const class _sos_Bag_node*_impl;
public :
   operator sos_Object(OBST_NO_ARGS) const;
   operator sos_Node(OBST_NO_ARGS) const;
   friend class _sos_Object_Bag;
   static sos_Bag_node make(const sos_Typed_id&);
   static sos_Bag_node make(const sos_Typed_id&_OBSThis,const _sos_Bag_node *_y){
         sos_Bag_node _x;_x._self=_OBSThis;_x._impl=_y;return _x;
   }
   static sos_Bag_node make(const obst_Root_class&);
   static sos_Bag_node clone(OBST_PARDECL(sos_Bag_node),sos_Container);
   void destroy(OBST_NO_ARGS)const;
   sos_Int hash_value(OBST_NO_ARGS)const;
private:
   sos_Int get_tag_no(OBST_NO_ARGS)const;
   void set_tag_no(sos_Int)const;
   sos_Int get_tag_max(OBST_NO_ARGS)const;
   void set_tag_max(sos_Int)const;
public:
   void check_list_cursor(OBST_PARDECL(sos_Aggregate))const;
   sos_Bool has_type(OBST_PARDECL(sos_Type))const;
   sos_Bool isa(OBST_PARDECL(sos_Type))const;
protected:
   static void local_assign(OBST_PARDECL(sos_Bag_node),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(sos_Bag_node),OBST_PARDECL(sos_Object),sos_Eq_kind);
public:
   static sos_Bag_node create(sos_Container,OBST_PARDECL(sos_Cursor),sos_Bool);
   static sos_Bag_node copy(OBST_PARDECL(sos_Bag_node),sos_Container);
   void assign(OBST_PARDECL(sos_Object))const;
   sos_Bool equal(OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
private:
   sos_Cursor get_map_cursor(OBST_NO_ARGS)const;
   void set_map_cursor(OBST_PARDECL(sos_Cursor))const;
public:
   sos_Bool like(OBST_PARDECL(sos_Object))const;
   sos_Bool get_list_cursor(OBST_NO_ARGS)const;
   void set_list_cursor(sos_Bool)const;
   sos_Type type(OBST_NO_ARGS)const;
   sos_Bool is_some(OBST_PARDECL(sos_Type))const;
   sos_Bool is_value(OBST_NO_ARGS)const;
   sos_Int size(OBST_NO_ARGS)const;
protected:
   static sos_Int local_hash_value(OBST_PARDECL(sos_Bag_node));
};
OBST_TMPDEF(extern,sos_Bag_node,_sos_Bag_node_tmp)
#define _sos_Bag_node_type _agg__tp_[20]
#define sos_Bag_node_type _agg_tp_[20]
class sos_Int_Set: public obst_Root_class 
{  friend class _sos_Object_Set;
   const class _sos_Object_Set*_impl;
public :
   operator sos_Object(OBST_NO_ARGS) const;
   operator sos_Aggregate(OBST_NO_ARGS) const;
   operator sos_Int_Collection(OBST_NO_ARGS) const;
   operator sos_Object_Collection(OBST_NO_ARGS) const;
   operator sos_Object_Set(OBST_NO_ARGS) const;
   static sos_Int_Set make(const sos_Typed_id&);
   static sos_Int_Set make(const sos_Typed_id&_OBSThis,const _sos_Object_Set *_y){
         sos_Int_Set _x;_x._self=_OBSThis;_x._impl=_y;return _x;
   }
   static sos_Int_Set make(const obst_Root_class&);
   void destroy(OBST_NO_ARGS)const;
   sos_Int hash_value(OBST_NO_ARGS)const;
   void operator+=(OBST_PARDECL(sos_Int_Set))const;
   void operator-=(OBST_PARDECL(sos_Int_Set))const;
   void operator*=(OBST_PARDECL(sos_Int_Set))const;
   sos_Bool operator<(OBST_PARDECL(sos_Int_Set))const;
   sos_Bool operator<=(OBST_PARDECL(sos_Int_Set))const;
   sos_Bool operator>(OBST_PARDECL(sos_Int_Set))const;
   sos_Bool operator>=(OBST_PARDECL(sos_Int_Set))const;
   sos_Bool is_element(sos_Int)const;
   sos_Int get(OBST_PARDECL(sos_Cursor))const;
   sos_Int card(OBST_NO_ARGS)const;
   sos_Cursor open_cursor(sos_Container =TEMP_CONTAINER)const;
   void close_cursor(OBST_PARDECL(sos_Cursor))const;
   sos_Cursor duplicate(OBST_PARDECL(sos_Cursor),sos_Container =TEMP_CONTAINER)const;
   sos_Bool to_last(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_pred(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
   sos_Bool is_empty(OBST_NO_ARGS)const;
   sos_Bool isa(OBST_PARDECL(sos_Type))const;
   static sos_Int_Set create(sos_Container,sos_Bool =FALSE,sos_Bool =FALSE,agg_Impl =AGG_AUTOMATIC);
   static sos_Int_Set copy(OBST_PARDECL(sos_Int_Set),sos_Container);
   void assign(OBST_PARDECL(sos_Object))const;
   sos_Bool equal(OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   void insert(sos_Int)const;
   void remove(sos_Int)const;
   void clear(OBST_NO_ARGS)const;
   sos_Bool to_succ(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
   void change_impl_type(agg_Impl)const;
   agg_Impl get_impl_type(OBST_NO_ARGS)const;
   sos_Bool like(OBST_PARDECL(sos_Object))const;
   sos_Bool get_list_cursor(OBST_NO_ARGS)const;
   void set_list_cursor(sos_Bool)const;
   sos_Type type(OBST_NO_ARGS)const;
   sos_Bool is_some(OBST_PARDECL(sos_Type))const;
   sos_Bool is_value(OBST_NO_ARGS)const;
   sos_Int size(OBST_NO_ARGS)const;
   static sos_Int_Set clone(OBST_PARDECL(sos_Int_Set),sos_Container);
   void remove_at(OBST_PARDECL(sos_Cursor))const;
   sos_Bool is_valid(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_first(OBST_PARDECL(sos_Cursor))const;
   void change_list_cursor(sos_Bool)const;
   void change(sos_Cstring,sos_Cstring)const;
   sos_Bool has_type(OBST_PARDECL(sos_Type))const;
};
OBST_TMPDEF(extern,sos_Int_Set,_sos_Int_Set_tmp)
#define _sos_Int_Set_type _agg__tp_[21]
#define sos_Int_Set_type _agg_tp_[21]
class sos_Int_Collection: public obst_Root_class 
{  friend class _sos_Object_Collection;
   const class _sos_Object_Collection*_impl;
public :
   operator sos_Object(OBST_NO_ARGS) const;
   operator sos_Aggregate(OBST_NO_ARGS) const;
   operator sos_Object_Collection(OBST_NO_ARGS) const;
   static sos_Int_Collection make(const sos_Typed_id&);
   static sos_Int_Collection make(const sos_Typed_id&_OBSThis,const _sos_Object_Collection *_y){
         sos_Int_Collection _x;_x._self=_OBSThis;_x._impl=_y;return _x;
   }
   static sos_Int_Collection make(const obst_Root_class&);
   static sos_Int_Collection clone(OBST_PARDECL(sos_Int_Collection),sos_Container);
   void destroy(OBST_NO_ARGS)const;
   sos_Int hash_value(OBST_NO_ARGS)const;
   sos_Bool is_element(sos_Int)const;
   sos_Int get(OBST_PARDECL(sos_Cursor))const;
   void change(sos_Cstring,sos_Cstring)const;
   sos_Bool is_empty(OBST_NO_ARGS)const;
   sos_Int card(OBST_NO_ARGS)const;
   sos_Cursor open_cursor(sos_Container =TEMP_CONTAINER)const;
   void close_cursor(OBST_PARDECL(sos_Cursor))const;
   sos_Cursor duplicate(OBST_PARDECL(sos_Cursor),sos_Container =TEMP_CONTAINER)const;
   sos_Bool is_valid(OBST_PARDECL(sos_Cursor))const;
   void remove_at(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_first(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_last(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_pred(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
   sos_Bool has_type(OBST_PARDECL(sos_Type))const;
   sos_Bool isa(OBST_PARDECL(sos_Type))const;
   void assign(OBST_PARDECL(sos_Object))const;
   sos_Bool equal(OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   sos_Bool like(OBST_PARDECL(sos_Object))const;
   void clear(OBST_NO_ARGS)const;
   sos_Bool to_succ(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
   sos_Bool get_list_cursor(OBST_NO_ARGS)const;
   void set_list_cursor(sos_Bool)const;
   sos_Type type(OBST_NO_ARGS)const;
   sos_Bool is_some(OBST_PARDECL(sos_Type))const;
   sos_Bool is_value(OBST_NO_ARGS)const;
   sos_Int size(OBST_NO_ARGS)const;
};
OBST_TMPDEF(extern,sos_Int_Collection,_sos_Int_Collection_tmp)
#define _sos_Int_Collection_type _agg__tp_[22]
#define sos_Int_Collection_type _agg_tp_[22]
class sos_String_List: public obst_Root_class 
{  friend class _sos_Object_List;
   const class _sos_Object_List*_impl;
public :
   operator sos_Object(OBST_NO_ARGS) const;
   operator sos_Aggregate(OBST_NO_ARGS) const;
   operator sos_String_Collection(OBST_NO_ARGS) const;
   operator sos_Object_Collection(OBST_NO_ARGS) const;
   operator sos_Object_List(OBST_NO_ARGS) const;
   static sos_String_List make(const sos_Typed_id&);
   static sos_String_List make(const sos_Typed_id&_OBSThis,const _sos_Object_List *_y){
         sos_String_List _x;_x._self=_OBSThis;_x._impl=_y;return _x;
   }
   static sos_String_List make(const obst_Root_class&);
   static sos_String_List clone(OBST_PARDECL(sos_String_List),sos_Container);
   void destroy(OBST_NO_ARGS)const;
   sos_Int hash_value(OBST_NO_ARGS)const;
   sos_Int find(OBST_PARDECL(sos_String))const;
   sos_String find_or_append(OBST_PARDECL(sos_String))const;
   void operator+=(OBST_PARDECL(sos_String_List))const;
   void insert_after(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_String))const;
   void set(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_String))const;
   sos_String get(OBST_PARDECL(sos_Cursor))const;
   void remove_at(OBST_PARDECL(sos_Cursor))const;
   sos_Int card(OBST_NO_ARGS)const;
   sos_Cursor open_cursor(sos_Container =TEMP_CONTAINER)const;
   void close_cursor(OBST_PARDECL(sos_Cursor))const;
   sos_Cursor duplicate(OBST_PARDECL(sos_Cursor),sos_Container =TEMP_CONTAINER)const;
   sos_Bool is_valid(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_first(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_last(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_pred(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
   void change_list_cursor(sos_Bool)const;
   sos_Bool is_element(OBST_PARDECL(sos_String))const;
   void change(sos_Cstring,sos_Cstring)const;
   sos_Bool is_empty(OBST_NO_ARGS)const;
   sos_Bool has_type(OBST_PARDECL(sos_Type))const;
   sos_Bool isa(OBST_PARDECL(sos_Type))const;
   static sos_String_List create(sos_Container,sos_Bool =FALSE,sos_Bool =FALSE);
   static sos_String_List copy(OBST_PARDECL(sos_String_List),sos_Container);
   void assign(OBST_PARDECL(sos_Object))const;
   sos_Bool equal(OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   void append(OBST_PARDECL(sos_String))const;
   void insert(sos_Int,OBST_PARDECL(sos_String))const;
   void clear(OBST_NO_ARGS)const;
   sos_Int size(OBST_NO_ARGS)const;
   sos_Int current_pos(OBST_PARDECL(sos_Cursor))const;
   void insert_before(OBST_PARDECL(sos_Cursor),OBST_PARDECL(sos_String))const;
   sos_Bool like(OBST_PARDECL(sos_Object))const;
   sos_Bool get_list_cursor(OBST_NO_ARGS)const;
   void set_list_cursor(sos_Bool)const;
   sos_Type type(OBST_NO_ARGS)const;
   void remove(sos_Int)const;
   sos_String get_nth(sos_Int)const;
   void set_nth(sos_Int,OBST_PARDECL(sos_String))const;
   sos_Bool move_cursor(OBST_PARDECL(sos_Cursor),sos_Int)const;
   sos_Bool to_succ(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
   sos_Bool is_some(OBST_PARDECL(sos_Type))const;
   sos_Bool is_value(OBST_NO_ARGS)const;
};
OBST_TMPDEF(extern,sos_String_List,_sos_String_List_tmp)
#define _sos_String_List_type _agg__tp_[23]
#define sos_String_List_type _agg_tp_[23]
class sos_String_Collection: public obst_Root_class 
{  friend class _sos_Object_Collection;
   const class _sos_Object_Collection*_impl;
public :
   operator sos_Object(OBST_NO_ARGS) const;
   operator sos_Aggregate(OBST_NO_ARGS) const;
   operator sos_Object_Collection(OBST_NO_ARGS) const;
   static sos_String_Collection make(const sos_Typed_id&);
   static sos_String_Collection make(const sos_Typed_id&_OBSThis,const _sos_Object_Collection *_y){
         sos_String_Collection _x;_x._self=_OBSThis;_x._impl=_y;return _x;
   }
   static sos_String_Collection make(const obst_Root_class&);
   static sos_String_Collection clone(OBST_PARDECL(sos_String_Collection),sos_Container);
   void destroy(OBST_NO_ARGS)const;
   sos_Int hash_value(OBST_NO_ARGS)const;
   sos_Bool is_element(OBST_PARDECL(sos_String))const;
   sos_String get(OBST_PARDECL(sos_Cursor))const;
   void change(sos_Cstring,sos_Cstring)const;
   sos_Bool is_empty(OBST_NO_ARGS)const;
   sos_Int card(OBST_NO_ARGS)const;
   sos_Cursor open_cursor(sos_Container =TEMP_CONTAINER)const;
   void close_cursor(OBST_PARDECL(sos_Cursor))const;
   sos_Cursor duplicate(OBST_PARDECL(sos_Cursor),sos_Container =TEMP_CONTAINER)const;
   sos_Bool is_valid(OBST_PARDECL(sos_Cursor))const;
   void remove_at(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_first(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_last(OBST_PARDECL(sos_Cursor))const;
   sos_Bool to_pred(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
   sos_Bool has_type(OBST_PARDECL(sos_Type))const;
   sos_Bool isa(OBST_PARDECL(sos_Type))const;
   void assign(OBST_PARDECL(sos_Object))const;
   sos_Bool equal(OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   sos_Bool like(OBST_PARDECL(sos_Object))const;
   void clear(OBST_NO_ARGS)const;
   sos_Bool to_succ(OBST_PARDECL(sos_Cursor),sos_Int =1)const;
   sos_Bool get_list_cursor(OBST_NO_ARGS)const;
   void set_list_cursor(sos_Bool)const;
   sos_Type type(OBST_NO_ARGS)const;
   sos_Bool is_some(OBST_PARDECL(sos_Type))const;
   sos_Bool is_value(OBST_NO_ARGS)const;
   sos_Int size(OBST_NO_ARGS)const;
};
OBST_TMPDEF(extern,sos_String_Collection,_sos_String_Collection_tmp)
#define _sos_String_Collection_type _agg__tp_[24]
#define sos_String_Collection_type _agg_tp_[24]
extern "C" void _agg_init_obst(int);
#endif
