/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the licence
 * you should have received along with this program.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */
#include "cfe_err.h"

const err_msg err_CFE_AMBIGUOUS_GEN_PARAMS="ambiguous generic parameters";
const err_msg err_CFE_AMBIGUOUS_METHODS="ambiguous methods";
const err_msg err_CFE_ASSIGN_WITHOUT_EQUAL="assign is defined but equal is not";
const err_msg err_CFE_CLASS_EXPECTED="class name expected";
const err_msg err_CFE_GENERIC_TYPE_EXPECTED="generic type expected";
const err_msg err_CFE_EQUAL_WITHOUT_HASH="equal is defined but hash_value is not";
const err_msg err_CFE_L_AND_T_ASSIGN="local_assign and total_assign defined";
const err_msg err_CFE_L_AND_T_EQUAL="local_equal and total_equal defined";
const err_msg err_CFE_L_AND_T_HASH="local_hash_value and total_hash_value defined";
const err_msg err_CFE_L_AND_T_FINALIZE="local_finalize and total_finalize defined";
const err_msg err_CFE_L_AND_T_INIT="local_initialize and total_initialize defined";
const err_msg err_CFE_FULL_GENERIC="type was used as class name; no generic allowed";
const err_msg err_CFE_GEN_PARAM_MISMATCH="generic parameter mismatch";
const err_msg err_CFE_FORWD_AS_ACT_GEN="forward class used as actual generic parameter";
const err_msg err_CFE_MANY_CREATE_PARAMS="too many create parameters";
const err_msg err_CFE_FEW_CREATE_PARAMS="too few create parameters";
const err_msg err_CFE_INTERNAL="internal compiler error";
const err_msg err_CFE_INVALID_EXT_SIZE="invalid size for external type";
const err_msg err_CFE_INVALID_IMPORT="invalid name of imported module";
const err_msg err_CFE_INVALID_LOCAL_METHOD="invalid signature of local method";
const err_msg err_CFE_INVALID_OVERLOADING="invalid overloading";
const err_msg err_CFE_INVALID_REDEFINITION="invalid redefinition";
const err_msg err_CFE_INVALID_ACCESS_RESTR="invalid access restriction in redefinition";
const err_msg err_CFE_DEFINITE_REDEFINED="invalid redefinition of definite method";
const err_msg err_CFE_DEFAULT_FOR_REFERENCE="default value for reference parameter not allowed";
const err_msg err_CFE_INVALID_TYPE_LIST="internal error: type-description list has unknown type";
const err_msg err_CFE_LEXICAL_ERROR="lexical error";
const err_msg err_CFE_MULTIPLE_TYPE_DECL="multiple type declaration";
const err_msg err_CFE_NO_FILE="no file";
const err_msg err_CFE_NO_GENERIC_TYPE="generic type not allowed";
const err_msg err_CFE_NO_KERNEL="no kernel schema";
const err_msg err_CFE_NO_RESERVED_SCHEMA_NAME="name is no *boot* schema name";
const err_msg err_CFE_NOT_DECLARED="no declaration in schema";
const err_msg err_CFE_RESERVED_SCHEMA_NAME="schema name is reserved";
const err_msg err_CFE_SCRAMBLED_INSTANTIATION="scrambled generic instantiation";
const err_msg err_CFE_TOO_MANY_LITERALS="too many literals";
const err_msg err_CFE_UNDECL_CLASS="undeclared class";
const err_msg err_CFE_UNKNOWN_SUPERCLASS="unknown superclass";
const err_msg err_CFE_UNKNOWN_GENERIC_CLASS="unknown generic class";
const err_msg err_CFE_USAGE="usage: cfe -v | [-E] [-v] <input file>";
const err_msg err_CFE_MULTIPLE_SUPERCLASS="multiply declared superclass";
const err_msg err_CFE_FORMAL_AS_SUPERCLASS="formal create parameter used as superclass";
const err_msg err_CFE_PRIVATE_METHOD_ABSTRACT="private method must not be abstract";
const err_msg err_CFE_ABSTRACT_COMP="keyword abstract illegal for components";

const err_msg err_CFE_NO_DEFINITE_FUNCS="definite functions not yet implemented";
const err_msg err_CFE_NO_LOCAL_FUNCS="local functions not allowed";
const err_msg err_CFE_NO_VALUE_FUNCS="value functions not allowed";

const err_msg err_CFE_NO_DEFINITE_COMPS="definite components not yet implemented";
const err_msg err_CFE_NO_STATIC_COMPS="static components not yet implemented";
const err_msg err_CFE_NO_VALUE_COMPS="value components not yet implemented";

/* --- old error messages ---
   const err_msg err_CFE_CONV_OP_ERROR="conversion operator with parameters";
   const err_msg err_CFE_MISSING_INIT="missing initialization";
   const err_msg err_CFE_RESERVED_METHOD_NAME="method name is reserved";
   const err_msg err_CFE_SUPER_CLASS_NOT_IMPL="instance as super class not implemented";
   const err_msg err_CFE_SYNTAX_ERROR="syntax error";
   const err_msg err_CFE_NO_REF_FOR_GEN_PARAM="generic parameter type not allowed for reference parameter";
*/
