/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the license
 * you should have received along with this software; either version 1.1 of
 * the license, or (at your option) any later version.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */
// OBST root container initialization facility (init)

#define OBST_IMP_FILE
#include "obst_stdinc.h"

#include "_obst_config.h"
#include "obst.h"
#include "obst_progstd.h"
#include "smg.h"
#include "dir_use.h"
// new for transactions
#include "sync_use.h"
#include "sync_decl.h"

#ifdef PROFILE
extern "C" void monitor(...);
#endif

EXPORT int init_main (int argc, char *argv[])
{
   sos_Directory dir;

   int fd;
   smg_String cnt_name = smg_String (obst_getenv(ENVVAR_CONTAINER)) + "/" + 1;
       
   fd = ::open(cnt_name.make_Cstring (SMG_BORROW),O_RDWR | O_CREAT | O_EXCL,0664);

        ::close(fd);

#ifndef LOCKD_CORRECT
     cnt_name += ".lck";
     fd = ::open(cnt_name.make_Cstring (SMG_BORROW),O_RDWR | O_CREAT | O_EXCL,0664); 
        ::close(fd);
#endif /* LOCKD_CORRECT */

   sos_String name = sos_String::create (TEMP_CONTAINER, "root");
   ROOT_CONTAINER.open (WRITING, WAITING);
   dir = sos_Object_Directory::create (ROOT_CONTAINER, name);
   ROOT_CONTAINER.close() ;

#ifdef PROFILE
   monitor (0);
#endif

   return 0;
}
