struct yywork;
# include "stdio.h"
# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN _msh_yybgin = _msh_yysvec + 1 +
# define INITIAL 0
# define YYLERR _msh_yysvec
# define YYSTATE (yyestate-_msh_yysvec-1)
# define YYOPTIM 1
# define YYLMAX BUFSIZ
# define output(c) putc(c,yyout)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
# define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
extern int yyleng; extern char yytext[];
extern int yymorfg;
extern char *yysptr, yysbuf[];
extern int yytchar;
FILE *yyin = {stdin}, *yyout = {stdout};
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
static struct yysvf *yyestate;
extern struct yysvf _msh_yysvec[], *_msh_yybgin;
 /* --------------------------------------------------------------------------
  * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
  *
  * You can use and distribute this software under the terms of the licence
  * you should have received along with this program.
  * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
  * Email: obst@xcc-ka.de.
  *
  * The license covers the source file msh.l and those parts of msh.l that are
  * copied into a file generated from msh.l.
  * --------------------------------------------------------------------------
  */
extern "C"
{
#ifndef FLEX_SCANNER 
#  ifdef HAVE_YYWRAP 
   int yywrap();
#  endif
#endif
   int yyreject();
   int yyless(int);
   int yyback(int*, int);
   int yyinput();
   void yyoutput (int);
   void yyunput (int);
   extern YYSTYPE yylval;
}

#include "obst_progstd.h"
#include "msh_err.h"

LOCAL int  yylook();
LOCAL void yyecho();

LOCAL int name_or_keyword ()
{  switch (yytext[0])
   {  case 'a':
      {  if (streql (yytext, "abstract")) return abstract_tok;
	 break;
      }
      case 'c':
      {  if      (streql (yytext, "class"))	 return class_tok;
         else if (streql (yytext, "commit"))	 return commit_tok;
         else if (streql (yytext, "comp"))	 return comp_tok;
         else if (streql (yytext, "create"))	 return create_tok;
         else if (streql (yytext, "create_par")) return create_par_tok;
	 break;
      }
      case 'd':
      {  if (streql (yytext, "definite")) return definite_tok;
	 break;
      }
      case 'e':
      {  if      (streql (yytext, "endversion")) return endversion_tok;
         else if (streql (yytext, "enum"))	 return enum_tok;
         else if (streql (yytext, "extern"))	 return extern_tok;
         else if (streql (yytext, "exit"))	 return exit_tok;
	 break;
      }
      case 'f':
      {  if (streql (yytext, "friend")) return friend_tok;
	 break;
      }
      case 'g':
      {  if (streql (yytext, "generate")) return generate_tok;
	 break;
      }
      case 'h':
      {  if (streql (yytext, "help")) return help_tok;
	 break;
      }
      case 'i':
      {  if      (streql (yytext, "import"))	    return import_tok;
         else if (streql (yytext, "init"))	    return init_tok;
         else if (streql (yytext, "insert"))	    return insert_tok;
         else if (streql (yytext, "instantiation")) return instantiation_tok;
	 break;
      }
      case 'l':
      {  if      (streql (yytext, "literal")) return literal_tok;
         else if (streql (yytext, "local"))   return local_tok;
	 break;
      }
      case 'm':
      {  if (streql (yytext, "method")) return method_tok;
	 break;
      }
      case 'n':
      {  if (streql (yytext, "name")) return nname_tok;
	 break;
      }
      case 'o':
      {  if (streql (yytext, "operator")) return operator_tok;
	 break;
      }
      case 'p':
      {  if      (streql (yytext, "param"))     return param_tok;
         else if (streql (yytext, "private"))   return private_tok;
         else if (streql (yytext, "protected")) return protected_tok;
         else if (streql (yytext, "prot_gen"))  return prot_gen_tok;
         else if (streql (yytext, "public"))    return public_tok;
         else if (streql (yytext, "print"))     return print_tok;
	 break;
      }
      case 'q':
      {  if (streql (yytext, "quit")) return quit_tok;
	 break;
      }
      case 'r':
      {  if      (streql (yytext, "recursive")) return recursive_tok;
         else if (streql (yytext, "ref"))	return ref_tok;
         else if (streql (yytext, "reset")) 	return reset_tok;
         else if (streql (yytext, "result")) 	return result_tok;
         else if (streql (yytext, "remove")) 	return remove_tok;
	 break;
      }
      case 's':
      {  if      (streql (yytext, "schema"))   return schema_tok;
         else if (streql (yytext, "scope"))    return scope_tok;
         else if (streql (yytext, "set"))      return set_tok;
         else if (streql (yytext, "size"))     return size_tok;
         else if (streql (yytext, "static"))   return static_tok;
         else if (streql (yytext, "subclass")) return subclass_tok;
         else if (streql (yytext, "super"))    return super_tok;
	 break;
      }
      case 't':
      {  if      (streql (yytext, "type"))    return type_tok;
         else if (streql (yytext, "typedef")) return typedef_tok;
	 break;
      }
      case 'u':
      {  if      (streql (yytext, "union"))  return union_tok;
         else if (streql (yytext, "update")) return update_tok;
	 break;
      }
      case 'w':
      {  if      (streql (yytext, "wait"))	  return wait_tok;
         else if (streql (yytext, "with"))	  return with_tok;
         else if (streql (yytext, "with_extern")) return with_extern_tok;
	 break;
      }
      default:
	 break;
   }
   return name_tok;
}

# define comment 2
# define YYNEWLINE 10
yylex(){
int nstr; extern int yyprevious;
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:
		{yyecho(); BEGIN comment;}
break;
case 2:
{yyecho();}
break;
case 3:
{yyecho(); BEGIN 0;}
break;
case 4:
{yymore();}
break;
case 5:
	{yyecho();}
break;
case 6:
		{yyecho(); return l_abr_tok;}
break;
case 7:
		{yyecho(); return r_abr_tok;}
break;
case 8:
		{yyecho(); return ampersand_tok;}
break;
case 9:
		{yyecho(); return ampersand_assign_tok;}
break;
case 10:
		{yyecho(); return and_tok;}
break;
case 11:
		{yyecho(); return assign_tok;}
break;
case 12:
		{yyecho(); return bar_tok;}
break;
case 13:
		{yyecho(); return bar_assign_tok;}
break;
case 14:
		{yyecho(); return l_br_tok;}
break;
case 15:
		{yyecho(); return r_br_tok;}
break;
case 16:
		{yyecho(); return l_brc_tok;}
break;
case 17:
		{yyecho(); return r_brc_tok;}
break;
case 18:
		{yyecho(); return circumflex_tok;}
break;
case 19:
		{yyecho(); return circumflex_assign_tok;}
break;
case 20:
		{yyecho(); return colon_tok;}
break;
case 21:
		{yyecho(); return period_tok;}
break;
case 22:
		{yyecho(); return comma_tok;}
break;
case 23:
		{yyecho(); return equal_tok;}
break;
case 24:
		{yyecho(); return greater_equal_tok;}
break;
case 25:
		{yyecho(); return less_equal_tok;}
break;
case 26:
		{yyecho(); return minus_tok;}
break;
case 27:
		{yyecho(); return minus_assign_tok;}
break;
case 28:
		{yyecho(); return not_equal_tok;}
break;
case 29:
		{yyecho(); return or_tok;}
break;
case 30:
		{yyecho(); return l_par_tok;}
break;
case 31:
		{yyecho(); return r_par_tok;}
break;
case 32:
		{yyecho(); return percent_tok;}
break;
case 33:
		{yyecho(); return percent_assign_tok;}
break;
case 34:
		{yyecho(); return plus_tok;}
break;
case 35:
		{yyecho(); return plus_assign_tok;}
break;
case 36:
		{yyecho(); return rshift_assign_tok;}
break;
case 37:
		{yyecho(); return lshift_assign_tok;}
break;
case 38:
		{yyecho(); return slash_tok;}
break;
case 39:
		{yyecho(); return slash_assign_tok;}
break;
case 40:
		{yyecho(); return star_tok;}
break;
case 41:
		{yyecho(); return star_assign_tok;}
break;
case 42:
		{yyecho(); return semicolon_tok;}
break;
case 43:
		{yyecho(); return exclam_tok;}
break;
case 44:
	{yyecho();
			 yylval.i = atoi (yytext);
			 return number_tok;}
break;
case 45:
{yyecho();
			 int tok = name_or_keyword();
			 if (tok == name_tok)
			 {  yylval.s = new char[yyleng+1];
			    strcpy (yylval.s, yytext);
			 }
			 return tok;}
break;
case 46:
{yyecho();
			 yylval.s = new char[yyleng-1];
			 strncpy (yylval.s, yytext+1, yyleng-2);
			 yylval.s [yyleng-2] = '\0';
			 return name_tok;}
break;
case 47:
		{yyecho();}
break;
case 48:
	{yyecho(); msh_prompt(); }
break;
case 49:
		{yyecho(); msh_error (err_USE, err_MSH_LEXICAL_ERROR);}
break;
case -1:
break;
default:
fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */
static int yyvstop[] = {
0,

49,
0,

47,
49,
0,

48,
0,

48,
49,
0,

43,
49,
0,

49,
0,

32,
49,
0,

8,
49,
0,

30,
49,
0,

31,
49,
0,

40,
49,
0,

34,
49,
0,

22,
49,
0,

26,
49,
0,

21,
49,
0,

38,
49,
0,

44,
49,
0,

20,
49,
0,

42,
49,
0,

6,
49,
0,

11,
49,
0,

7,
49,
0,

45,
49,
0,

14,
49,
0,

15,
49,
0,

18,
49,
0,

16,
49,
0,

12,
49,
0,

17,
49,
0,

49,
0,

47,
49,
0,

2,
48,
0,

48,
49,
0,

43,
49,
0,

49,
0,

32,
49,
0,

8,
49,
0,

30,
49,
0,

31,
49,
0,

4,
40,
49,
0,

34,
49,
0,

22,
49,
0,

26,
49,
0,

21,
49,
0,

38,
49,
0,

44,
49,
0,

20,
49,
0,

42,
49,
0,

6,
49,
0,

11,
49,
0,

7,
49,
0,

45,
49,
0,

14,
49,
0,

15,
49,
0,

18,
49,
0,

16,
49,
0,

12,
49,
0,

17,
49,
0,

28,
0,

33,
0,

10,
0,

9,
0,

41,
0,

35,
0,

27,
0,

1,
0,

39,
0,

44,
0,

25,
0,

23,
0,

24,
0,

45,
0,

19,
0,

13,
0,

29,
0,

2,
0,

4,
0,

28,
0,

33,
0,

10,
0,

9,
0,

3,
0,

35,
0,

27,
0,

1,
4,
0,

39,
0,

44,
0,

25,
0,

23,
0,

24,
0,

45,
0,

19,
0,

13,
0,

29,
0,

46,
0,

5,
0,

37,
0,

36,
0,

46,
0,

2,
5,
0,

4,
0,

37,
0,

36,
0,

3,
0,
0};
# define YYTYPE char
static struct yywork { YYTYPE verify, advance; } yycrank[] = {
0,0,	0,0,	1,5,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,6,	1,7,	
0,0,	1,8,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,9,	1,10,	
0,0,	0,0,	1,11,	1,12,	
0,0,	1,13,	1,14,	1,15,	
1,16,	1,17,	1,18,	1,19,	
1,20,	1,21,	12,66,	20,71,	
50,98,	86,92,	98,98,	114,117,	
20,72,	0,0,	0,0,	1,22,	
1,23,	1,24,	1,25,	1,26,	
9,63,	11,65,	1,27,	15,68,	
16,69,	18,70,	20,73,	2,9,	
2,10,	12,67,	25,77,	2,11,	
2,12,	30,81,	2,13,	2,14,	
38,87,	2,16,	2,17,	2,18,	
2,19,	2,20,	24,75,	24,76,	
26,78,	26,79,	39,88,	40,89,	
1,28,	32,82,	1,29,	1,30,	
2,22,	2,23,	2,24,	2,25,	
2,26,	45,93,	47,94,	44,92,	
41,90,	53,99,	53,100,	3,34,	
54,101,	49,95,	55,102,	55,103,	
59,105,	56,104,	49,96,	3,35,	
3,36,	44,68,	3,37,	61,106,	
75,110,	79,111,	99,115,	103,116,	
1,31,	1,32,	1,33,	41,91,	
49,97,	2,28,	56,104,	2,29,	
2,30,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3,38,	
3,39,	88,112,	104,104,	3,40,	
3,41,	0,0,	3,42,	3,43,	
3,44,	3,45,	3,46,	3,47,	
3,48,	3,49,	3,50,	88,88,	
32,83,	0,0,	0,0,	104,104,	
0,0,	2,31,	2,32,	2,33,	
3,51,	3,52,	3,53,	3,54,	
3,55,	0,0,	0,0,	3,56,	
88,88,	0,0,	0,0,	0,0,	
4,38,	4,39,	0,0,	0,0,	
4,40,	4,41,	61,107,	4,42,	
4,43,	0,0,	4,45,	4,46,	
4,47,	4,48,	4,49,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3,57,	0,0,	3,58,	
3,59,	4,51,	4,52,	4,53,	
4,54,	4,55,	21,74,	21,74,	
21,74,	21,74,	21,74,	21,74,	
21,74,	21,74,	21,74,	21,74,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3,60,	3,61,	3,62,	
0,0,	0,0,	4,57,	0,0,	
4,58,	4,59,	0,0,	10,64,	
10,64,	10,64,	10,64,	10,64,	
10,64,	10,64,	10,64,	10,64,	
10,64,	10,64,	10,64,	10,64,	
10,64,	10,64,	10,64,	10,64,	
10,64,	10,64,	10,64,	10,64,	
10,64,	10,64,	10,64,	10,64,	
10,64,	0,0,	4,60,	4,61,	
4,62,	10,64,	0,0,	10,64,	
10,64,	10,64,	10,64,	10,64,	
10,64,	10,64,	10,64,	10,64,	
10,64,	10,64,	10,64,	10,64,	
10,64,	10,64,	10,64,	10,64,	
10,64,	10,64,	10,64,	10,64,	
10,64,	10,64,	10,64,	10,64,	
10,64,	27,80,	27,80,	27,80,	
27,80,	27,80,	27,80,	27,80,	
27,80,	27,80,	27,80,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	27,80,	27,80,	
27,80,	27,80,	27,80,	27,80,	
27,80,	27,80,	27,80,	27,80,	
27,80,	27,80,	27,80,	27,80,	
27,80,	27,80,	27,80,	27,80,	
27,80,	27,80,	27,80,	27,80,	
27,80,	27,80,	27,80,	27,80,	
0,0,	0,0,	0,0,	0,0,	
27,80,	0,0,	27,80,	27,80,	
27,80,	27,80,	27,80,	27,80,	
27,80,	27,80,	27,80,	27,80,	
27,80,	27,80,	27,80,	27,80,	
27,80,	27,80,	27,80,	27,80,	
27,80,	27,80,	27,80,	27,80,	
27,80,	27,80,	27,80,	27,80,	
34,84,	64,108,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
34,84,	34,85,	0,0,	34,84,	
0,0,	0,0,	0,0,	64,64,	
64,64,	64,64,	64,64,	64,64,	
64,64,	64,64,	64,64,	64,64,	
64,64,	72,72,	0,0,	0,0,	
0,0,	96,96,	0,0,	0,0,	
0,0,	72,72,	72,109,	0,0,	
72,72,	96,96,	96,113,	0,0,	
96,96,	34,86,	0,0,	0,0,	
0,0,	0,0,	0,0,	34,84,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
34,84,	0,0,	72,72,	0,0,	
0,0,	0,0,	96,114,	0,0,	
72,72,	0,0,	0,0,	0,0,	
96,96,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	72,72,	0,0,	0,0,	
0,0,	96,96,	0,0,	0,0,	
0,0};
struct yysvf _msh_yysvec[] = {
0,	0,	0,
yycrank+-1,	0,		0,	
yycrank+-38,	_msh_yysvec+1,	0,	
yycrank+-106,	0,		0,	
yycrank+-143,	_msh_yysvec+3,	0,	
yycrank+0,	0,		yyvstop+1,
yycrank+0,	0,		yyvstop+3,
yycrank+0,	0,		yyvstop+6,
yycrank+0,	0,		yyvstop+8,
yycrank+3,	0,		yyvstop+11,
yycrank+174,	0,		yyvstop+14,
yycrank+4,	0,		yyvstop+16,
yycrank+12,	0,		yyvstop+19,
yycrank+0,	0,		yyvstop+22,
yycrank+0,	0,		yyvstop+25,
yycrank+6,	0,		yyvstop+28,
yycrank+7,	0,		yyvstop+31,
yycrank+0,	0,		yyvstop+34,
yycrank+8,	0,		yyvstop+37,
yycrank+0,	0,		yyvstop+40,
yycrank+9,	0,		yyvstop+43,
yycrank+158,	0,		yyvstop+46,
yycrank+0,	0,		yyvstop+49,
yycrank+0,	0,		yyvstop+52,
yycrank+26,	0,		yyvstop+55,
yycrank+13,	0,		yyvstop+58,
yycrank+27,	0,		yyvstop+61,
yycrank+249,	0,		yyvstop+64,
yycrank+0,	0,		yyvstop+67,
yycrank+0,	0,		yyvstop+70,
yycrank+16,	0,		yyvstop+73,
yycrank+0,	0,		yyvstop+76,
yycrank+32,	0,		yyvstop+79,
yycrank+0,	0,		yyvstop+82,
yycrank+-371,	0,		yyvstop+85,
yycrank+0,	_msh_yysvec+34,	yyvstop+87,
yycrank+0,	0,		yyvstop+90,
yycrank+0,	_msh_yysvec+34,	yyvstop+93,
yycrank+-19,	_msh_yysvec+34,	yyvstop+96,
yycrank+-25,	_msh_yysvec+34,	yyvstop+99,
yycrank+-30,	_msh_yysvec+34,	yyvstop+101,
yycrank+-66,	_msh_yysvec+34,	yyvstop+104,
yycrank+0,	_msh_yysvec+34,	yyvstop+107,
yycrank+0,	_msh_yysvec+34,	yyvstop+110,
yycrank+56,	0,		yyvstop+113,
yycrank+-40,	_msh_yysvec+34,	yyvstop+117,
yycrank+0,	_msh_yysvec+34,	yyvstop+120,
yycrank+-41,	_msh_yysvec+34,	yyvstop+123,
yycrank+0,	_msh_yysvec+34,	yyvstop+126,
yycrank+-67,	_msh_yysvec+34,	yyvstop+129,
yycrank+-4,	_msh_yysvec+34,	yyvstop+132,
yycrank+0,	_msh_yysvec+34,	yyvstop+135,
yycrank+0,	_msh_yysvec+34,	yyvstop+138,
yycrank+-45,	_msh_yysvec+34,	yyvstop+141,
yycrank+-47,	_msh_yysvec+34,	yyvstop+144,
yycrank+-49,	_msh_yysvec+34,	yyvstop+147,
yycrank+-65,	_msh_yysvec+34,	yyvstop+150,
yycrank+0,	_msh_yysvec+34,	yyvstop+153,
yycrank+0,	_msh_yysvec+34,	yyvstop+156,
yycrank+-51,	_msh_yysvec+34,	yyvstop+159,
yycrank+0,	_msh_yysvec+34,	yyvstop+162,
yycrank+-58,	_msh_yysvec+34,	yyvstop+165,
yycrank+0,	_msh_yysvec+34,	yyvstop+168,
yycrank+0,	0,		yyvstop+171,
yycrank+339,	_msh_yysvec+10,	0,	
yycrank+0,	0,		yyvstop+173,
yycrank+0,	0,		yyvstop+175,
yycrank+0,	0,		yyvstop+177,
yycrank+0,	0,		yyvstop+179,
yycrank+0,	0,		yyvstop+181,
yycrank+0,	0,		yyvstop+183,
yycrank+0,	0,		yyvstop+185,
yycrank+-396,	0,		0,	
yycrank+0,	0,		yyvstop+187,
yycrank+0,	_msh_yysvec+21,	yyvstop+189,
yycrank+59,	0,		0,	
yycrank+0,	0,		yyvstop+191,
yycrank+0,	0,		yyvstop+193,
yycrank+0,	0,		yyvstop+195,
yycrank+60,	0,		0,	
yycrank+0,	_msh_yysvec+27,	yyvstop+197,
yycrank+0,	0,		yyvstop+199,
yycrank+0,	0,		yyvstop+201,
yycrank+0,	0,		yyvstop+203,
yycrank+0,	_msh_yysvec+34,	0,	
yycrank+0,	0,		yyvstop+205,
yycrank+6,	0,		yyvstop+207,
yycrank+0,	_msh_yysvec+34,	yyvstop+209,
yycrank+-107,	_msh_yysvec+34,	0,	
yycrank+0,	_msh_yysvec+34,	yyvstop+211,
yycrank+0,	_msh_yysvec+34,	yyvstop+213,
yycrank+0,	_msh_yysvec+34,	yyvstop+215,
yycrank+0,	0,		yyvstop+217,
yycrank+0,	_msh_yysvec+34,	yyvstop+219,
yycrank+0,	_msh_yysvec+34,	yyvstop+221,
yycrank+0,	_msh_yysvec+86,	yyvstop+223,
yycrank+-400,	0,		0,	
yycrank+0,	_msh_yysvec+34,	yyvstop+226,
yycrank+-6,	_msh_yysvec+34,	yyvstop+228,
yycrank+-61,	_msh_yysvec+34,	0,	
yycrank+0,	_msh_yysvec+34,	yyvstop+230,
yycrank+0,	_msh_yysvec+34,	yyvstop+232,
yycrank+0,	_msh_yysvec+34,	yyvstop+234,
yycrank+-62,	_msh_yysvec+34,	0,	
yycrank+-94,	_msh_yysvec+34,	yyvstop+236,
yycrank+0,	_msh_yysvec+34,	yyvstop+238,
yycrank+0,	_msh_yysvec+34,	yyvstop+240,
yycrank+0,	_msh_yysvec+34,	yyvstop+242,
yycrank+0,	0,		yyvstop+244,
yycrank+0,	0,		yyvstop+246,
yycrank+0,	0,		yyvstop+248,
yycrank+0,	0,		yyvstop+250,
yycrank+0,	_msh_yysvec+34,	yyvstop+252,
yycrank+0,	0,		yyvstop+254,
yycrank+-8,	_msh_yysvec+72,	yyvstop+257,
yycrank+0,	_msh_yysvec+34,	yyvstop+259,
yycrank+0,	_msh_yysvec+34,	yyvstop+261,
yycrank+0,	_msh_yysvec+72,	yyvstop+263,
0,	0,	0};
static struct yywork *yytop = yycrank+465;
struct yysvf *_msh_yybgin = _msh_yysvec+1;
static char yymatch[] = {
00  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,011 ,012 ,01  ,014 ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
011 ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,'*' ,01  ,01  ,01  ,01  ,01  ,
'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,
'0' ,'0' ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,01  ,01  ,01  ,01  ,'A' ,
01  ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,01  ,01  ,01  ,01  ,01  ,
0};
static char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
#ifndef lint
static	char ncform_sccsid[] = "@(#)ncform 1.6 88/02/08 SMI"; /* from S5R2 1.2 */
#endif

int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
extern char yytext[];
static struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
extern char yysbuf[];
extern char *yysptr;
extern int *yyfnd;
extern struct yysvf *yyestate;
extern int yyprevious;
static yylook(){
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych, yyfirst;
	struct yywork *yyr;
# ifdef LEXDEBUG
	int debug;
# endif
	char *yylastch;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
		yylastch = yytext;
	else {
		yymorfg=0;
		yylastch = yytext+yyleng;
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = _msh_yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)fprintf(yyout,"state %d\n",yystate-_msh_yysvec-1);
# endif
			yyt = yystate->yystoff;
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == yycrank)break;
				}
			*yylastch++ = yych = input();
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;
			if ( (int)yyt > (int)yycrank){
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+_msh_yysvec == yystate){
					if(yyt->advance+_msh_yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+_msh_yysvec;
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if((int)yyt < (int)yycrank) {		/* r < yycrank */
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+_msh_yysvec == yystate){
					if(yyt->advance+_msh_yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+_msh_yysvec;
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+_msh_yysvec == yystate){
					if(yyt->advance+_msh_yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+_msh_yysvec;
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank){
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"fall back to state %d\n",yystate-_msh_yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"state %d char ",yystate-_msh_yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			fprintf(yyout,"stopped at %d with ",*(lsp-1)-_msh_yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
				yyleng = yylastch-yytext+1;
				yytext[yyleng] = 0;
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"\nmatch ");
					sprint(yytext);
					fprintf(yyout," action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
		if (yytext[0] == 0  /* && feof(yyin) */)
			{
			yysptr=yysbuf;
			return(0);
			}
		yyprevious = yytext[0] = input();
		if (yyprevious>0)
			output(yyprevious);
		yylastch=yytext;
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}
