#ifndef sync_IMPL_H
#define sync_IMPL_H 1
#ifdef __GNUG__
#pragma interface
#endif
#include "sync_use.h"
#include "knl_obst.h"
#include "agg_obst.h"
class _Transaction;
class _BlockableTA;
class _LockingTA;
class _BlockedTA;
class _SyncData;
class _Queued;
class _LockingSync;
class _SyncObj;
class _SyncCont;
extern void**_sync_obj_;
class _Transaction:virtual public _sos_Object
{  friend class Transaction;
   virtual sos_Offset _offset_Transaction(OBST_NO_ARGS)const {return 8;}
public:
   friend class _SyncObj;
   friend class _SyncCont;
   friend class _Queued;
   virtual void destroy(const sos_Typed_id&)const;
   virtual sos_Int hash_value(const sos_Typed_id&)const;
   virtual sos_Int get_socket_port(const sos_Typed_id&)const;
   virtual void set_socket_port(const sos_Typed_id&,OBST_PARDECL(sos_Int))const;
   virtual sos_String get_hostname(const sos_Typed_id&)const;
   virtual void set_hostname(const sos_Typed_id&,OBST_PARDECL(sos_String))const;
   virtual sos_Transaction_tp get_type(const sos_Typed_id&)const;
protected:
   virtual void set_type(const sos_Typed_id&,OBST_PARDECL(sos_Transaction_tp))const;
public:
   virtual sos_Int get_proc_fd(const sos_Typed_id&)const;
protected:
   virtual void set_proc_fd(const sos_Typed_id&,OBST_PARDECL(sos_Int))const;
public:
   virtual sos_Error get_error(const sos_Typed_id&)const;
protected:
   virtual void set_error(const sos_Typed_id&,OBST_PARDECL(sos_Error))const;
public:
   virtual sos_Int get_hostproc_id(const sos_Typed_id&)const;
private:
   virtual void set_hostproc_id(const sos_Typed_id&,OBST_PARDECL(sos_Int))const;
public:
   virtual void abort(const sos_Typed_id&)OBST_ISPURE
   virtual ta_Access_mode is_accessed(const sos_Typed_id&,OBST_PARDECL(SyncObj))const;
   virtual void release_SO(const sos_Typed_id&,OBST_PARDECL(SyncObj))const;
protected:
   virtual void intern_abort(const sos_Typed_id&)OBST_ISPURE
   virtual void extern_abort(const sos_Typed_id&)OBST_ISPURE
   static void local_assign(OBST_PARDECL(Transaction),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(Transaction),OBST_PARDECL(sos_Object),sos_Eq_kind);
public:
   virtual void assign(const sos_Typed_id&,OBST_PARDECL(sos_Object))const;
   virtual sos_Bool equal(const sos_Typed_id&,OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   virtual sos_Int get_socket_seq_nr(const sos_Typed_id&)const;
protected:
   virtual void set_socket_seq_nr(const sos_Typed_id&,OBST_PARDECL(sos_Int))const;
public:
   virtual SyncObj_Set get_openset(const sos_Typed_id&)const;
protected:
   virtual void set_openset(const sos_Typed_id&,OBST_PARDECL(SyncObj_Set))const;
public:
   virtual sos_Int get_user_id(const sos_Typed_id&)const;
private:
   virtual void set_user_id(const sos_Typed_id&,OBST_PARDECL(sos_Int))const;
public:
   virtual void commit(const sos_Typed_id&)OBST_ISPURE
protected:
   static void local_finalize(OBST_PARDECL(Transaction));
public:
   virtual sos_Bool get_implicit(const sos_Typed_id&)const;
   virtual void set_implicit(const sos_Typed_id&,OBST_PARDECL(sos_Bool))const;
   virtual sos_Transaction_status get_status(const sos_Typed_id&)const;
protected:
   virtual void set_status(const sos_Typed_id&,OBST_PARDECL(sos_Transaction_status))const;
public:
   virtual SyncObj_Set get_readset(const sos_Typed_id&)const;
protected:
   virtual void set_readset(const sos_Typed_id&,OBST_PARDECL(SyncObj_Set))const;
public:
   virtual SyncObj_Set get_writeset(const sos_Typed_id&)const;
protected:
   virtual void set_writeset(const sos_Typed_id&,OBST_PARDECL(SyncObj_Set))const;
public:
   virtual sos_Int get_ts(const sos_Typed_id&)const;
private:
   virtual void set_ts(const sos_Typed_id&,OBST_PARDECL(sos_Int))const;
public:
   virtual sos_Bool is_released(const sos_Typed_id&,OBST_PARDECL(SyncObj))const;
   virtual void get_SO(const sos_Typed_id&,OBST_PARDECL(SyncObj),sos_Access_mode)const;
   static void local_initialize(OBST_PARDECL(Transaction));
protected:
   static sos_Int local_hash_value(OBST_PARDECL(Transaction));
};
class _BlockableTA:virtual public _Transaction
{  friend class BlockableTA;
   virtual sos_Offset _offset_BlockableTA(OBST_NO_ARGS)const {return 100;}
public:
   virtual void destroy(const sos_Typed_id&)const;
   virtual sos_Int hash_value(const sos_Typed_id&)const;
   virtual SyncObj get_waits_for(const sos_Typed_id&)const;
   virtual void set_waits_for(const sos_Typed_id&,OBST_PARDECL(SyncObj))const;
protected:
   static void local_assign(OBST_PARDECL(BlockableTA),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(BlockableTA),OBST_PARDECL(sos_Object),sos_Eq_kind);
public:
   virtual void assign(const sos_Typed_id&,OBST_PARDECL(sos_Object))const;
   virtual sos_Bool equal(const sos_Typed_id&,OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
protected:
   static sos_Int local_hash_value(OBST_PARDECL(BlockableTA));
};
class _LockingTA:virtual public _BlockableTA
{  friend class LockingTA;
public:
   _LockingTA(OBST_NO_ARGS){_size=116;}
   virtual sos_Object _clone(const sos_Typed_id&,OBST_PARDECL(sos_Container))const;
   virtual void destroy(const sos_Typed_id&)const;
   virtual sos_Int hash_value(const sos_Typed_id&)const;
   virtual void abort(const sos_Typed_id&)const;
   virtual void intern_abort(const sos_Typed_id&)const;
   virtual void extern_abort(const sos_Typed_id&)const;
   virtual void assign(const sos_Typed_id&,OBST_PARDECL(sos_Object))const;
   virtual sos_Bool equal(const sos_Typed_id&,OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   virtual void commit(const sos_Typed_id&)const;
   static void local_initialize(OBST_PARDECL(LockingTA));
};
#define _LockingTA_OBJ_ ((_LockingTA*)_sync_obj_[0])
class _BlockedTA:virtual public _sos_Object
{  friend class BlockedTA;
   virtual sos_Offset _offset_BlockedTA(OBST_NO_ARGS)const {return 8;}
public:
   _BlockedTA(OBST_NO_ARGS){_size=25;}
   static void _copy_comps(const BlockedTA&,const BlockedTA&);
   virtual sos_Object _clone(const sos_Typed_id&,OBST_PARDECL(sos_Container))const;
   static void _create_comps(const BlockedTA&,OBST_PARDECL(Transaction),sos_Access_mode);
   virtual void destroy(const sos_Typed_id&)const;
   virtual void assign(const sos_Typed_id&,OBST_PARDECL(sos_Object))const;
   virtual sos_Bool equal(const sos_Typed_id&,OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   virtual sos_Int hash_value(const sos_Typed_id&)const;
   virtual Transaction get_ta(const sos_Typed_id&)const;
   virtual void set_ta(const sos_Typed_id&,OBST_PARDECL(Transaction))const;
   virtual sos_Access_mode get_am(const sos_Typed_id&)const;
   virtual void set_am(const sos_Typed_id&,OBST_PARDECL(sos_Access_mode))const;
protected:
   static void local_assign(OBST_PARDECL(BlockedTA),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(BlockedTA),OBST_PARDECL(sos_Object),sos_Eq_kind);
   static sos_Int local_hash_value(OBST_PARDECL(BlockedTA));
};
#define _BlockedTA_OBJ_ ((_BlockedTA*)_sync_obj_[1])
class _SyncData:virtual public _sos_Object
{  friend class SyncData;
   virtual sos_Offset _offset_SyncData(OBST_NO_ARGS)const {return 8;}
public:
   _SyncData(OBST_NO_ARGS){_size=13;}
   static void _copy_comps(const SyncData&,const SyncData&);
   virtual sos_Object _clone(const sos_Typed_id&,OBST_PARDECL(sos_Container))const;
   static void _create_comps(const SyncData&,sos_Container);
   virtual void destroy(const sos_Typed_id&)const;
   virtual void assign(const sos_Typed_id&,OBST_PARDECL(sos_Object))const;
   virtual sos_Bool equal(const sos_Typed_id&,OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   virtual sos_Int hash_value(const sos_Typed_id&)const;
   virtual sos_Error get_error(const sos_Typed_id&)const;
protected:
   virtual void set_error(const sos_Typed_id&,OBST_PARDECL(sos_Error))const;
public:
   virtual sos_Container get_soscontainer(const sos_Typed_id&)const;
private:
   virtual void set_soscontainer(const sos_Typed_id&,OBST_PARDECL(sos_Container))const;
protected:
   static void local_assign(OBST_PARDECL(SyncData),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(SyncData),OBST_PARDECL(sos_Object),sos_Eq_kind);
   static sos_Int local_hash_value(OBST_PARDECL(SyncData));
};
#define _SyncData_OBJ_ ((_SyncData*)_sync_obj_[2])
class _Queued:virtual public _SyncData
{  friend class Queued;
   virtual sos_Offset _offset_Queued(OBST_NO_ARGS)const {return 13;}
public:
   _Queued(OBST_NO_ARGS){_size=47;}
   virtual sos_Object _clone(const sos_Typed_id&,OBST_PARDECL(sos_Container))const;
   virtual void destroy(const sos_Typed_id&)const;
   virtual sos_Int hash_value(const sos_Typed_id&)const;
   virtual sos_Bool get_awaking(const sos_Typed_id&)const;
protected:
   virtual void set_awaking(const sos_Typed_id&,OBST_PARDECL(sos_Bool))const;
public:
   virtual Lock_Mode get_lock(const sos_Typed_id&)const;
protected:
   virtual void set_lock(const sos_Typed_id&,OBST_PARDECL(Lock_Mode))const;
public:
   virtual BlockedTA_List get_queue(const sos_Typed_id&)const;
protected:
   virtual void set_queue(const sos_Typed_id&,OBST_PARDECL(BlockedTA_List))const;
public:
   virtual sos_Int q_takeout(const sos_Typed_id&,OBST_PARDECL(Transaction),sos_Bool)const;
   virtual sos_Int q_takeout(const sos_Typed_id&,OBST_PARDECL(BlockedTA))const;
protected:
   static void local_assign(OBST_PARDECL(Queued),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(Queued),OBST_PARDECL(sos_Object),sos_Eq_kind);
public:
   virtual void assign(const sos_Typed_id&,OBST_PARDECL(sos_Object))const;
   virtual sos_Bool equal(const sos_Typed_id&,OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   virtual sos_Int_BlockedTA_Mapping_Hash get_accesses(const sos_Typed_id&)const;
   virtual void set_accesses(const sos_Typed_id&,OBST_PARDECL(sos_Int_BlockedTA_Mapping_Hash))const;
   virtual sos_Int enqueue(const sos_Typed_id&,OBST_PARDECL(Transaction),sos_Access_mode,sos_Int =0)const;
   virtual void dequeue(const sos_Typed_id&)const;
   static void local_initialize(OBST_PARDECL(Queued));
protected:
   static sos_Int local_hash_value(OBST_PARDECL(Queued));
};
#define _Queued_OBJ_ ((_Queued*)_sync_obj_[3])
class _LockingSync:virtual public _Queued
{  friend class LockingSync;
public:
   _LockingSync(OBST_NO_ARGS){_size=47;}
   friend class _LockingTA;
   virtual sos_Object _clone(const sos_Typed_id&,OBST_PARDECL(sos_Container))const;
   virtual void destroy(const sos_Typed_id&)const;
   virtual sos_Int hash_value(const sos_Typed_id&)const;
protected:
   virtual sos_Bool tpl_readlock(const sos_Typed_id&,OBST_PARDECL(LockingTA),sos_Sync_mode)const;
   virtual sos_Bool tpl_writelock(const sos_Typed_id&,OBST_PARDECL(LockingTA),sos_Sync_mode)const;
   virtual void tpl_commit(const sos_Typed_id&,OBST_PARDECL(LockingTA))const;
   virtual void tpl_release_n_wakeup(const sos_Typed_id&,OBST_PARDECL(LockingTA))const;
private:
   virtual void grant(const sos_Typed_id&,OBST_PARDECL(LockingTA),Lock_Mode)const;
public:
#ifndef OBST_CAN_OVERLOAD_INHERITED
   virtual sos_Int q_takeout(const sos_Typed_id&_OBSThis,OBST_PARDECL(Transaction) _p0,sos_Bool _p1)const{
return _Queued::q_takeout(_OBSThis,_p0,_p1);
}
#endif
#ifndef OBST_CAN_OVERLOAD_INHERITED
   virtual sos_Int q_takeout(const sos_Typed_id&_OBSThis,OBST_PARDECL(BlockedTA) _p0)const{
return _Queued::q_takeout(_OBSThis,_p0);
}
#endif
   virtual void assign(const sos_Typed_id&,OBST_PARDECL(sos_Object))const;
   virtual sos_Bool equal(const sos_Typed_id&,OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
protected:
   virtual void tpl_abort(const sos_Typed_id&,OBST_PARDECL(LockingTA))const;
};
#define _LockingSync_OBJ_ ((_LockingSync*)_sync_obj_[4])
class _SyncObj:virtual public _LockingSync
{  friend class SyncObj;
public:
   _SyncObj(OBST_NO_ARGS){_size=47;}
   virtual sos_Object _clone(const sos_Typed_id&,OBST_PARDECL(sos_Container))const;
   virtual void destroy(const sos_Typed_id&)const;
   virtual sos_Int hash_value(const sos_Typed_id&)const;
   virtual sos_Bool get(const sos_Typed_id&,sos_Access_mode,sos_Sync_mode)const;
protected:
   virtual sos_Bool tpl_readlock(const sos_Typed_id&,OBST_PARDECL(LockingTA),sos_Sync_mode)const;
   virtual sos_Bool tpl_writelock(const sos_Typed_id&,OBST_PARDECL(LockingTA),sos_Sync_mode)const;
public:
#ifndef OBST_CAN_OVERLOAD_INHERITED
   virtual sos_Int q_takeout(const sos_Typed_id&_OBSThis,OBST_PARDECL(Transaction) _p0,sos_Bool _p1)const{
return _Queued::q_takeout(_OBSThis,_p0,_p1);
}
#endif
#ifndef OBST_CAN_OVERLOAD_INHERITED
   virtual sos_Int q_takeout(const sos_Typed_id&_OBSThis,OBST_PARDECL(BlockedTA) _p0)const{
return _Queued::q_takeout(_OBSThis,_p0);
}
#endif
   virtual void assign(const sos_Typed_id&,OBST_PARDECL(sos_Object))const;
   virtual sos_Bool equal(const sos_Typed_id&,OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   virtual void release(const sos_Typed_id&)const;
   static void local_initialize(OBST_PARDECL(SyncObj));
protected:
   static void local_finalize(OBST_PARDECL(SyncObj));
};
#define _SyncObj_OBJ_ ((_SyncObj*)_sync_obj_[5])
class _SyncCont:virtual public _sos_Object
{  friend class SyncCont;
   virtual sos_Offset _offset_SyncCont(OBST_NO_ARGS)const {return 8;}
public:
   _SyncCont(OBST_NO_ARGS){_size=78;}
   virtual sos_Object _clone(const sos_Typed_id&,OBST_PARDECL(sos_Container))const;
   virtual void destroy(const sos_Typed_id&)const;
   virtual sos_Int hash_value(const sos_Typed_id&)const;
   virtual sos_Error get_error(const sos_Typed_id&)const;
protected:
   virtual void set_error(const sos_Typed_id&,OBST_PARDECL(sos_Error))const;
public:
   virtual sos_Int_SyncObj_Mapping_Hash get_sync_tab(const sos_Typed_id&)const;
private:
   virtual void set_sync_tab(const sos_Typed_id&,OBST_PARDECL(sos_Int_SyncObj_Mapping_Hash))const;
public:
   virtual sos_Int_Transaction_Mapping_Hash get_opta_tab(const sos_Typed_id&)const;
private:
   virtual void set_opta_tab(const sos_Typed_id&,OBST_PARDECL(sos_Int_Transaction_Mapping_Hash))const;
public:
   virtual void release_SO(const sos_Typed_id&,sos_Container)const;
protected:
   static void local_assign(OBST_PARDECL(SyncCont),OBST_PARDECL(sos_Object));
   static sos_Bool local_equal(OBST_PARDECL(SyncCont),OBST_PARDECL(sos_Object),sos_Eq_kind);
public:
   virtual void assign(const sos_Typed_id&,OBST_PARDECL(sos_Object))const;
   virtual sos_Bool equal(const sos_Typed_id&,OBST_PARDECL(sos_Object),sos_Eq_kind =EQ_STRONG)const;
   virtual sos_String_sos_Char_Mapping_Hash get_host_tab(const sos_Typed_id&)const;
private:
   virtual void set_host_tab(const sos_Typed_id&,OBST_PARDECL(sos_String_sos_Char_Mapping_Hash))const;
public:
   virtual void insert_TA(const sos_Typed_id&,OBST_PARDECL(Transaction))const;
protected:
   static void local_finalize(OBST_PARDECL(SyncCont));
public:
   virtual sos_Int_Transaction_Mapping_Hash get_ta_tab(const sos_Typed_id&)const;
private:
   virtual void set_ta_tab(const sos_Typed_id&,OBST_PARDECL(sos_Int_Transaction_Mapping_Hash))const;
public:
   virtual sos_Int get_ts(const sos_Typed_id&)const;
private:
   virtual void set_ts(const sos_Typed_id&,OBST_PARDECL(sos_Int))const;
public:
   virtual sos_Char get_host_id(const sos_Typed_id&)const;
private:
   virtual void set_host_id(const sos_Typed_id&,OBST_PARDECL(sos_Char))const;
public:
   static SyncCont get_root(OBST_NO_ARGS);
   virtual sos_Bool exists_TA(const sos_Typed_id&,sos_Int)const;
   virtual void remove_TA(const sos_Typed_id&,OBST_PARDECL(Transaction))const;
   virtual SyncObj get_SO(const sos_Typed_id&,sos_Container)const;
   virtual sos_Int get_HP(const sos_Typed_id&)const;
   virtual sos_Int get_TS(const sos_Typed_id&)const;
   virtual sos_Bool process_check(const sos_Typed_id&,sos_Int,sos_Bool =FALSE)const;
   virtual void process_remove(const sos_Typed_id&,sos_Int)const;
   static void local_initialize(OBST_PARDECL(SyncCont));
protected:
   static sos_Int local_hash_value(OBST_PARDECL(SyncCont));
};
#define _SyncCont_OBJ_ ((_SyncCont*)_sync_obj_[6])
#endif
