/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the license
 * you should have received along with this software; either version 1.1 of
 * the license, or (at your option) any later version.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */
#define OBST_IMP_STREAM
#include "obst_stdinc.h"

#include "obst.h"
#include "dir_use.h"
#include "sfb_use.h"

extern sfb_Grammar sfb_structurer (sos_Container);
extern void sfb_flattener (ostream&,sfb_Grammar);

int main (int argc, char *argv[])
{  obst_init (argc, argv);

   sos_Container cnt = sos_Container::create();
   sfb_Grammar g = sfb_structurer (cnt);

   if (g != NO_OBJECT)
   {  cnt.commit();
      sos_Object_Directory::set_wd_from_env();
      sos_Directory wd = sos_Object_Directory::get_wd();
      wd.container().open (WRITING, WAITING);
      wd.insert (g.get_name(), g);
      wd.container().close ();

      sfb_flattener (cout, g);
   }
   else
   {  cnt.destroy(); cnt.close();
   }
   return 0;
}
