/* =================================================================== */
/*       EXPORT FILE                                               === */
/* =================================================================== */
/*                                                                     */
/* CONCEPT: Name Space Concept                                         */
/*                                                                     */
/*                                                                     */
/* =================================================================== */
#ifndef NSPC
#define NSPC 1

/* =================================================================== */

// NULL elements
#define NSP_NO_NSP add_Name_Space::make(NO_OBJECT)
#define NSPEL_NO_NSPEL add_Name_Space_Element::make(NO_OBJECT)


// constant values
const int NSPEL_MAX_NAME_LENGTH = 60;
const int NSPEL_MAX_PATH_LENGTH = 600;

// error constants
const int NSP_EXISTING_NAME = 120;
// const int NSP_NOT_EXISTING = 121;
const int NSP_WRONG_PATHNAME = 122;
const int NSP_DEL_NOT_PERMITTED = 123;
const int NSP_INSERT_NOT_PERMITTED = 124;
const int NSP_RENAME_NOT_PERMITTED = 133;
const int NSP_NAME_TOO_LONG = 130;

const int NSPEL_CHAR_NOT_ALLOWED = 125;
const int NSPEL_PATHNAME_EXISTING =126;
// 127 and 128 are used in Name_Space_Element.c
const int NSPEL_MOVE_FAILED = 129;
const int NSPEL_RENAME_FAILED = 134;
const int NSPEL_CORRECTED_NAME = 136;
const int NSPEL_LOST_AND_FOUND = 137;

extern void print_nsp_recursive (add_Name_Space_Element);
  // prints a description of a Name_Space hierarchy to cout.

#endif

